/* menubar.c generated by valac 0.54.5, the Vala compiler
 * generated from menubar.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 4 -*-
 *
 * Copyright (C) 2011,2012 Canonical Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Robert Ancell <robert.ancell@canonical.com>
 *          Michael Terry <michael.terry@canonical.com>
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gtk/gtk.h>
#include <cairo-gobject.h>
#include <glib/gi18n-lib.h>
#include "config.h"
#include <signal.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <gdk/gdk.h>
#include <lightdm.h>
#include <stdio.h>
#include <gtk/gtkx.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <X11/Xregion.h>
#include <atk/atk.h>
#include <sys/utsname.h>

#define MENU_BAR_HEIGHT 24
#define UG_SETTINGS_KEY_ONSCREEN_KEYBOARD "onscreen-keyboard"
#define UG_SETTINGS_KEY_HIGH_CONTRAST "high-contrast"
#define UG_SETTINGS_KEY_SCREEN_READER "screen-reader"
#define UG_SETTINGS_KEY_SHOW_QUIT "show-quit"
#define UG_SETTINGS_KEY_SHOW_CLOCK "show-clock"
#define UG_SETTINGS_KEY_CLOCK_FORMAT "clock-format"
#define UG_SETTINGS_KEY_SHOW_POWER "show-power"
#define UG_SETTINGS_KEY_SHOW_KEYBOARD "show-keyboard"
#define UG_SETTINGS_KEY_SHOW_A11Y "show-a11y"
#define UG_SETTINGS_KEY_SHOW_HOSTNAME "show-hostname"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define UPOWER_TYPE_DAEMON (upower_daemon_get_type ())
#define UPOWER_DAEMON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), UPOWER_TYPE_DAEMON, UPowerDaemon))
#define UPOWER_IS_DAEMON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), UPOWER_TYPE_DAEMON))
#define UPOWER_DAEMON_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), UPOWER_TYPE_DAEMON, UPowerDaemonIface))

typedef struct _UPowerDaemon UPowerDaemon;
typedef struct _UPowerDaemonIface UPowerDaemonIface;

#define UPOWER_TYPE_DAEMON_PROXY (upower_daemon_proxy_get_type ())
enum  {
	UPOWER_DAEMON_DEVICE_ADDED_SIGNAL,
	UPOWER_DAEMON_DEVICE_REMOVED_SIGNAL,
	UPOWER_DAEMON_DEVICE_CHANGED_SIGNAL,
	UPOWER_DAEMON_CHANGED_SIGNAL,
	UPOWER_DAEMON_SLEEPING_SIGNAL,
	UPOWER_DAEMON_RESUMING_SIGNAL,
	UPOWER_DAEMON_NUM_SIGNALS
};
static guint upower_daemon_signals[UPOWER_DAEMON_NUM_SIGNALS] = {0};
typedef GDBusProxy UPowerDaemonProxy;
typedef GDBusProxyClass UPowerDaemonProxyClass;
#define _g_free0(var) (var = (g_free (var), NULL))

#define UPOWER_TYPE_DEVICE (upower_device_get_type ())
#define UPOWER_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), UPOWER_TYPE_DEVICE, UPowerDevice))
#define UPOWER_IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), UPOWER_TYPE_DEVICE))
#define UPOWER_DEVICE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), UPOWER_TYPE_DEVICE, UPowerDeviceIface))

typedef struct _UPowerDevice UPowerDevice;
typedef struct _UPowerDeviceIface UPowerDeviceIface;

#define UPOWER_TYPE_DEVICE_PROXY (upower_device_proxy_get_type ())
enum  {
	UPOWER_DEVICE_CHANGED_SIGNAL,
	UPOWER_DEVICE_NUM_SIGNALS
};
static guint upower_device_signals[UPOWER_DEVICE_NUM_SIGNALS] = {0};
typedef GDBusProxy UPowerDeviceProxy;
typedef GDBusProxyClass UPowerDeviceProxyClass;

#define TYPE_MENU_BAR (menu_bar_get_type ())
#define MENU_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MENU_BAR, MenuBar))
#define MENU_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MENU_BAR, MenuBarClass))
#define IS_MENU_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MENU_BAR))
#define IS_MENU_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MENU_BAR))
#define MENU_BAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MENU_BAR, MenuBarClass))

typedef struct _MenuBar MenuBar;
typedef struct _MenuBarClass MenuBarClass;
typedef struct _MenuBarPrivate MenuBarPrivate;

#define TYPE_BACKGROUND (background_get_type ())
#define BACKGROUND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKGROUND, Background))
#define BACKGROUND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKGROUND, BackgroundClass))
#define IS_BACKGROUND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKGROUND))
#define IS_BACKGROUND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKGROUND))
#define BACKGROUND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKGROUND, BackgroundClass))

typedef struct _Background Background;
typedef struct _BackgroundClass BackgroundClass;

#define TYPE_MAIN_WINDOW (main_window_get_type ())
#define MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MAIN_WINDOW, MainWindow))
#define MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MAIN_WINDOW, MainWindowClass))
#define IS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MAIN_WINDOW))
#define IS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MAIN_WINDOW))
#define MAIN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MAIN_WINDOW, MainWindowClass))

typedef struct _MainWindow MainWindow;
typedef struct _MainWindowClass MainWindowClass;
enum  {
	MENU_BAR_0_PROPERTY,
	MENU_BAR_BACKGROUND_PROPERTY,
	MENU_BAR_HIGH_CONTRAST_PROPERTY,
	MENU_BAR_KEYBOARD_WINDOW_PROPERTY,
	MENU_BAR_ACCEL_GROUP_PROPERTY,
	MENU_BAR_MAIN_WINDOW_PROPERTY,
	MENU_BAR_NUM_PROPERTIES
};
static GParamSpec* menu_bar_properties[MENU_BAR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef enum  {
	BACKGROUND_DRAW_FLAGS_NONE = 1 << 0,
	BACKGROUND_DRAW_FLAGS_GRID = 1 << 1,
	BACKGROUND_DRAW_FLAGS_SPAN = 1 << 2
} BackgroundDrawFlags;

#define BACKGROUND_TYPE_DRAW_FLAGS (background_draw_flags_get_type ())
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _MenuBarQueryUpowerDeviceData MenuBarQueryUpowerDeviceData;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
typedef enum  {
	SHUTDOWN_DIALOG_TYPE_LOGOUT,
	SHUTDOWN_DIALOG_TYPE_SHUTDOWN,
	SHUTDOWN_DIALOG_TYPE_RESTART
} ShutdownDialogType;

#define TYPE_SHUTDOWN_DIALOG_TYPE (shutdown_dialog_type_get_type ())
#define _fclose0(var) ((var == NULL) ? NULL : (var = (fclose (var), NULL)))

#define TYPE_SLICK_GREETER (slick_greeter_get_type ())
#define SLICK_GREETER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SLICK_GREETER, SlickGreeter))
#define SLICK_GREETER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SLICK_GREETER, SlickGreeterClass))
#define IS_SLICK_GREETER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SLICK_GREETER))
#define IS_SLICK_GREETER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SLICK_GREETER))
#define SLICK_GREETER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SLICK_GREETER, SlickGreeterClass))

typedef struct _SlickGreeter SlickGreeter;
typedef struct _SlickGreeterClass SlickGreeterClass;
typedef struct _SlickGreeterPrivate SlickGreeterPrivate;

struct _UPowerDaemonIface {
	GTypeInterface parent_iface;
	char** (*enumerate_devices) (UPowerDaemon* self, gint* result_length1, GError** error);
	gchar* (*get_daemon_version) (UPowerDaemon* self);
	gboolean (*get_on_battery) (UPowerDaemon* self);
	gboolean (*get_on_low_battery) (UPowerDaemon* self);
	gboolean (*get_lid_is_present) (UPowerDaemon* self);
	gboolean (*get_lid_is_closed) (UPowerDaemon* self);
};

struct _UPowerDeviceIface {
	GTypeInterface parent_iface;
	guint (*get_Type) (UPowerDevice* self);
	gboolean (*get_power_supply) (UPowerDevice* self);
	gboolean (*get_online) (UPowerDevice* self);
	gboolean (*get_is_present) (UPowerDevice* self);
	guint (*get_state) (UPowerDevice* self);
	gboolean (*get_is_rechargeable) (UPowerDevice* self);
	gdouble (*get_capacity) (UPowerDevice* self);
	gint64 (*get_time_to_empty) (UPowerDevice* self);
	gint64 (*get_time_to_full) (UPowerDevice* self);
	gdouble (*get_energy) (UPowerDevice* self);
	gdouble (*get_energy_empty) (UPowerDevice* self);
	gdouble (*get_energy_full) (UPowerDevice* self);
	gdouble (*get_energy_full_design) (UPowerDevice* self);
	gdouble (*get_energy_rate) (UPowerDevice* self);
	gdouble (*get_percentage) (UPowerDevice* self);
	gdouble (*get_voltage) (UPowerDevice* self);
	guint (*get_technology) (UPowerDevice* self);
	gchar* (*get_vendor) (UPowerDevice* self);
	gchar* (*get_model) (UPowerDevice* self);
	gchar* (*get_serial) (UPowerDevice* self);
};

struct _MenuBar {
	GtkMenuBar parent_instance;
	MenuBarPrivate * priv;
};

struct _MenuBarClass {
	GtkMenuBarClass parent_class;
};

struct _MenuBarPrivate {
	Background* _background;
	gboolean _high_contrast;
	GtkWindow* _keyboard_window;
	GtkAccelGroup* _accel_group;
	MainWindow* _main_window;
	gchar* default_theme_name;
	gchar* clock_format;
	GtkCheckMenuItem* high_contrast_item;
	GPid keyboard_pid;
	GPid reader_pid;
	GtkCheckMenuItem* onscreen_keyboard_item;
	GtkLabel* clock_label;
	UPowerDaemon* upowerd;
	GtkMenuItem* power_menu_item;
	GtkLabel* power_label;
	GtkImage* power_icon;
};

struct _MenuBarQueryUpowerDeviceData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MenuBar* self;
	char* dev_path;
	UPowerDevice* dev;
	UPowerDevice* _tmp0_;
	UPowerDevice* _tmp1_;
	UPowerDevice* _tmp2_;
	GError* io;
	GError* _tmp3_;
	const gchar* _tmp4_;
	guint type;
	UPowerDevice* _tmp5_;
	guint _tmp6_;
	guint _tmp7_;
	gboolean _tmp8_;
	UPowerDevice* _tmp9_;
	gboolean _tmp10_;
	gboolean _tmp11_;
	UPowerDevice* _tmp12_;
	GError* _inner_error0_;
};

struct _SlickGreeter {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SlickGreeterPrivate * priv;
	gboolean test_mode;
	gboolean orca_needs_kick;
};

struct _SlickGreeterClass {
	GTypeClass parent_class;
	void (*finalize) (SlickGreeter *self);
};

static gint MenuBar_private_offset;
static gpointer menu_bar_parent_class = NULL;
VALA_EXTERN SlickGreeter* slick_greeter_singleton;

VALA_EXTERN GType upower_daemon_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint upower_daemon_register_object (void* object,
                                     GDBusConnection* connection,
                                     const gchar* path,
                                     GError** error);
VALA_EXTERN GType upower_daemon_get_type (void) G_GNUC_CONST ;
VALA_EXTERN char** upower_daemon_enumerate_devices (UPowerDaemon* self,
                                        gint* result_length1,
                                        GError** error);
VALA_EXTERN gchar* upower_daemon_get_daemon_version (UPowerDaemon* self);
VALA_EXTERN gboolean upower_daemon_get_on_battery (UPowerDaemon* self);
VALA_EXTERN gboolean upower_daemon_get_on_low_battery (UPowerDaemon* self);
VALA_EXTERN gboolean upower_daemon_get_lid_is_present (UPowerDaemon* self);
VALA_EXTERN gboolean upower_daemon_get_lid_is_closed (UPowerDaemon* self);
static GType upower_daemon_get_type_once (void);
static void upower_daemon_proxy_g_signal (GDBusProxy* proxy,
                                   const gchar* sender_name,
                                   const gchar* signal_name,
                                   GVariant* parameters);
static void _dbus_handle_upower_daemon_device_added (UPowerDaemon* self,
                                              GVariant* parameters);
static void _dbus_handle_upower_daemon_device_removed (UPowerDaemon* self,
                                                GVariant* parameters);
static void _dbus_handle_upower_daemon_device_changed (UPowerDaemon* self,
                                                GVariant* parameters);
static void _dbus_handle_upower_daemon_changed (UPowerDaemon* self,
                                         GVariant* parameters);
static void _dbus_handle_upower_daemon_sleeping (UPowerDaemon* self,
                                          GVariant* parameters);
static void _dbus_handle_upower_daemon_resuming (UPowerDaemon* self,
                                          GVariant* parameters);
static char** upower_daemon_proxy_enumerate_devices (UPowerDaemon* self,
                                              gint* result_length1,
                                              GError** error);
static gchar* upower_daemon_dbus_proxy_get_daemon_version (UPowerDaemon* self);
static gboolean upower_daemon_dbus_proxy_get_on_battery (UPowerDaemon* self);
static gboolean upower_daemon_dbus_proxy_get_on_low_battery (UPowerDaemon* self);
static gboolean upower_daemon_dbus_proxy_get_lid_is_present (UPowerDaemon* self);
static gboolean upower_daemon_dbus_proxy_get_lid_is_closed (UPowerDaemon* self);
static void upower_daemon_proxy_upower_daemon_interface_init (UPowerDaemonIface* iface);
static void _dbus_upower_daemon_enumerate_devices (UPowerDaemon* self,
                                            GVariant* _parameters_,
                                            GDBusMethodInvocation* invocation);
static void upower_daemon_dbus_interface_method_call (GDBusConnection* connection,
                                               const gchar* sender,
                                               const gchar* object_path,
                                               const gchar* interface_name,
                                               const gchar* method_name,
                                               GVariant* parameters,
                                               GDBusMethodInvocation* invocation,
                                               gpointer user_data);
static GVariant* upower_daemon_dbus_interface_get_property (GDBusConnection* connection,
                                                     const gchar* sender,
                                                     const gchar* object_path,
                                                     const gchar* interface_name,
                                                     const gchar* property_name,
                                                     GError** error,
                                                     gpointer user_data);
static GVariant* _dbus_upower_daemon_get_daemon_version (UPowerDaemon* self);
static GVariant* _dbus_upower_daemon_get_on_battery (UPowerDaemon* self);
static GVariant* _dbus_upower_daemon_get_on_low_battery (UPowerDaemon* self);
static GVariant* _dbus_upower_daemon_get_lid_is_present (UPowerDaemon* self);
static GVariant* _dbus_upower_daemon_get_lid_is_closed (UPowerDaemon* self);
static gboolean upower_daemon_dbus_interface_set_property (GDBusConnection* connection,
                                                    const gchar* sender,
                                                    const gchar* object_path,
                                                    const gchar* interface_name,
                                                    const gchar* property_name,
                                                    GVariant* value,
                                                    GError** error,
                                                    gpointer user_data);
static void _dbus_upower_daemon_device_added (GObject* _sender,
                                       const char* device,
                                       gpointer* _data);
static void _dbus_upower_daemon_device_removed (GObject* _sender,
                                         const char* device,
                                         gpointer* _data);
static void _dbus_upower_daemon_device_changed (GObject* _sender,
                                         const char* device,
                                         gpointer* _data);
static void _dbus_upower_daemon_changed (GObject* _sender,
                                  gpointer* _data);
static void _dbus_upower_daemon_sleeping (GObject* _sender,
                                   gpointer* _data);
static void _dbus_upower_daemon_resuming (GObject* _sender,
                                   gpointer* _data);
static void _upower_daemon_unregister_object (gpointer user_data);
VALA_EXTERN GType upower_device_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType upower_device_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint upower_device_register_object (void* object,
                                     GDBusConnection* connection,
                                     const gchar* path,
                                     GError** error);
VALA_EXTERN guint upower_device_get_Type (UPowerDevice* self);
VALA_EXTERN gboolean upower_device_get_power_supply (UPowerDevice* self);
VALA_EXTERN gboolean upower_device_get_online (UPowerDevice* self);
VALA_EXTERN gboolean upower_device_get_is_present (UPowerDevice* self);
VALA_EXTERN guint upower_device_get_state (UPowerDevice* self);
VALA_EXTERN gboolean upower_device_get_is_rechargeable (UPowerDevice* self);
VALA_EXTERN gdouble upower_device_get_capacity (UPowerDevice* self);
VALA_EXTERN gint64 upower_device_get_time_to_empty (UPowerDevice* self);
VALA_EXTERN gint64 upower_device_get_time_to_full (UPowerDevice* self);
VALA_EXTERN gdouble upower_device_get_energy (UPowerDevice* self);
VALA_EXTERN gdouble upower_device_get_energy_empty (UPowerDevice* self);
VALA_EXTERN gdouble upower_device_get_energy_full (UPowerDevice* self);
VALA_EXTERN gdouble upower_device_get_energy_full_design (UPowerDevice* self);
VALA_EXTERN gdouble upower_device_get_energy_rate (UPowerDevice* self);
VALA_EXTERN gdouble upower_device_get_percentage (UPowerDevice* self);
VALA_EXTERN gdouble upower_device_get_voltage (UPowerDevice* self);
VALA_EXTERN guint upower_device_get_technology (UPowerDevice* self);
VALA_EXTERN gchar* upower_device_get_vendor (UPowerDevice* self);
VALA_EXTERN gchar* upower_device_get_model (UPowerDevice* self);
VALA_EXTERN gchar* upower_device_get_serial (UPowerDevice* self);
static GType upower_device_get_type_once (void);
static void upower_device_proxy_g_signal (GDBusProxy* proxy,
                                   const gchar* sender_name,
                                   const gchar* signal_name,
                                   GVariant* parameters);
static void _dbus_handle_upower_device_changed (UPowerDevice* self,
                                         GVariant* parameters);
static guint upower_device_dbus_proxy_get_Type (UPowerDevice* self);
static gboolean upower_device_dbus_proxy_get_power_supply (UPowerDevice* self);
static gboolean upower_device_dbus_proxy_get_online (UPowerDevice* self);
static gboolean upower_device_dbus_proxy_get_is_present (UPowerDevice* self);
static guint upower_device_dbus_proxy_get_state (UPowerDevice* self);
static gboolean upower_device_dbus_proxy_get_is_rechargeable (UPowerDevice* self);
static gdouble upower_device_dbus_proxy_get_capacity (UPowerDevice* self);
static gint64 upower_device_dbus_proxy_get_time_to_empty (UPowerDevice* self);
static gint64 upower_device_dbus_proxy_get_time_to_full (UPowerDevice* self);
static gdouble upower_device_dbus_proxy_get_energy (UPowerDevice* self);
static gdouble upower_device_dbus_proxy_get_energy_empty (UPowerDevice* self);
static gdouble upower_device_dbus_proxy_get_energy_full (UPowerDevice* self);
static gdouble upower_device_dbus_proxy_get_energy_full_design (UPowerDevice* self);
static gdouble upower_device_dbus_proxy_get_energy_rate (UPowerDevice* self);
static gdouble upower_device_dbus_proxy_get_percentage (UPowerDevice* self);
static gdouble upower_device_dbus_proxy_get_voltage (UPowerDevice* self);
static guint upower_device_dbus_proxy_get_technology (UPowerDevice* self);
static gchar* upower_device_dbus_proxy_get_vendor (UPowerDevice* self);
static gchar* upower_device_dbus_proxy_get_model (UPowerDevice* self);
static gchar* upower_device_dbus_proxy_get_serial (UPowerDevice* self);
static void upower_device_proxy_upower_device_interface_init (UPowerDeviceIface* iface);
static void upower_device_dbus_interface_method_call (GDBusConnection* connection,
                                               const gchar* sender,
                                               const gchar* object_path,
                                               const gchar* interface_name,
                                               const gchar* method_name,
                                               GVariant* parameters,
                                               GDBusMethodInvocation* invocation,
                                               gpointer user_data);
static GVariant* upower_device_dbus_interface_get_property (GDBusConnection* connection,
                                                     const gchar* sender,
                                                     const gchar* object_path,
                                                     const gchar* interface_name,
                                                     const gchar* property_name,
                                                     GError** error,
                                                     gpointer user_data);
static GVariant* _dbus_upower_device_get_Type (UPowerDevice* self);
static GVariant* _dbus_upower_device_get_power_supply (UPowerDevice* self);
static GVariant* _dbus_upower_device_get_online (UPowerDevice* self);
static GVariant* _dbus_upower_device_get_is_present (UPowerDevice* self);
static GVariant* _dbus_upower_device_get_state (UPowerDevice* self);
static GVariant* _dbus_upower_device_get_is_rechargeable (UPowerDevice* self);
static GVariant* _dbus_upower_device_get_capacity (UPowerDevice* self);
static GVariant* _dbus_upower_device_get_time_to_empty (UPowerDevice* self);
static GVariant* _dbus_upower_device_get_time_to_full (UPowerDevice* self);
static GVariant* _dbus_upower_device_get_energy (UPowerDevice* self);
static GVariant* _dbus_upower_device_get_energy_empty (UPowerDevice* self);
static GVariant* _dbus_upower_device_get_energy_full (UPowerDevice* self);
static GVariant* _dbus_upower_device_get_energy_full_design (UPowerDevice* self);
static GVariant* _dbus_upower_device_get_energy_rate (UPowerDevice* self);
static GVariant* _dbus_upower_device_get_percentage (UPowerDevice* self);
static GVariant* _dbus_upower_device_get_voltage (UPowerDevice* self);
static GVariant* _dbus_upower_device_get_technology (UPowerDevice* self);
static GVariant* _dbus_upower_device_get_vendor (UPowerDevice* self);
static GVariant* _dbus_upower_device_get_model (UPowerDevice* self);
static GVariant* _dbus_upower_device_get_serial (UPowerDevice* self);
static gboolean upower_device_dbus_interface_set_property (GDBusConnection* connection,
                                                    const gchar* sender,
                                                    const gchar* object_path,
                                                    const gchar* interface_name,
                                                    const gchar* property_name,
                                                    GVariant* value,
                                                    GError** error,
                                                    gpointer user_data);
static void _dbus_upower_device_changed (GObject* _sender,
                                  gpointer* _data);
static void _upower_device_unregister_object (gpointer user_data);
VALA_EXTERN GType menu_bar_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MenuBar, g_object_unref)
VALA_EXTERN GType background_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Background, g_object_unref)
VALA_EXTERN GType main_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MainWindow, g_object_unref)
VALA_EXTERN MenuBar* menu_bar_new (Background* bg,
                       GtkAccelGroup* ag,
                       MainWindow* mw);
VALA_EXTERN MenuBar* menu_bar_construct (GType object_type,
                             Background* bg,
                             GtkAccelGroup* ag,
                             MainWindow* mw);
static gboolean menu_bar_real_draw (GtkWidget* base,
                             cairo_t* c);
VALA_EXTERN Background* menu_bar_get_background (MenuBar* self);
VALA_EXTERN GType background_draw_flags_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void background_draw_full (Background* self,
                           cairo_t* c,
                           BackgroundDrawFlags flags);
VALA_EXTERN void menu_bar_set_keyboard_state (MenuBar* self);
VALA_EXTERN gboolean ug_settings_get_boolean (const gchar* key);
static void menu_bar_on_sleeping (MenuBar* self);
static void menu_bar_on_resuming (MenuBar* self);
static gboolean menu_bar_query_upower_daemon (MenuBar* self);
static void menu_bar_on_changed (MenuBar* self);
static void menu_bar_on_power_device_added (MenuBar* self,
                                     const char* device);
static void menu_bar_query_upower_device (MenuBar* self,
                                   const char* dev_path,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_);
static void menu_bar_query_upower_device_finish (MenuBar* self,
                                          GAsyncResult* _res_);
static void menu_bar_on_power_device_changed (MenuBar* self,
                                       const char* device);
static void menu_bar_query_upower_device_data_free (gpointer _data);
static gboolean menu_bar_query_upower_device_co (MenuBarQueryUpowerDeviceData* _data_);
static void menu_bar_update_power (MenuBar* self,
                            UPowerDevice* device);
static void menu_bar_on_power_device_removed (MenuBar* self,
                                       const char* device);
static gboolean menu_bar_update_clock (MenuBar* self);
static void menu_bar_close_pid (MenuBar* self,
                         GPid* pid);
VALA_EXTERN void menu_bar_cleanup (MenuBar* self);
static void menu_bar_real_get_preferred_height (GtkWidget* base,
                                         gint* min,
                                         gint* nat);
static GtkMenuItem* menu_bar_make_a11y_item (MenuBar* self);
static void menu_bar_keyboard_toggled_cb (MenuBar* self,
                                   GtkCheckMenuItem* item);
static void _menu_bar_keyboard_toggled_cb_gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                                                gpointer self);
static void menu_bar_high_contrast_toggled_cb (MenuBar* self,
                                        GtkCheckMenuItem* item);
static void _menu_bar_high_contrast_toggled_cb_gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                                                     gpointer self);
VALA_EXTERN GtkAccelGroup* menu_bar_get_accel_group (MenuBar* self);
static void menu_bar_screen_reader_toggled_cb (MenuBar* self,
                                        GtkCheckMenuItem* item);
static void _menu_bar_screen_reader_toggled_cb_gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                                                     gpointer self);
static GtkMenuItem* menu_bar_make_session_item (MenuBar* self);
static void ___lambda6_ (MenuBar* self);
static void ____lambda6__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
static void ___lambda7_ (MenuBar* self);
static void ____lambda7__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
static void menu_bar_shutdown_cb (MenuBar* self,
                           GtkMenuItem* item);
static void _menu_bar_shutdown_cb_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                   gpointer self);
static GtkMenuItem* menu_bar_make_keyboard_item (MenuBar* self);
VALA_EXTERN MainWindow* menu_bar_get_main_window (MenuBar* self);
VALA_EXTERN GType shutdown_dialog_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void main_window_show_shutdown_dialog (MainWindow* self,
                                       ShutdownDialogType type);
VALA_EXTERN gboolean ug_settings_set_boolean (const gchar* key,
                                  gboolean value);
VALA_EXTERN GtkWindow* menu_bar_get_keyboard_window (MenuBar* self);
static void menu_bar_set_keyboard_window (MenuBar* self,
                                   GtkWindow* value);
static void menu_bar_set_high_contrast (MenuBar* self,
                                 gboolean value);
VALA_EXTERN gboolean menu_bar_get_high_contrast (MenuBar* self);
VALA_EXTERN gpointer slick_greeter_ref (gpointer instance);
VALA_EXTERN void slick_greeter_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_slick_greeter (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags);
VALA_EXTERN void value_set_slick_greeter (GValue* value,
                              gpointer v_object);
VALA_EXTERN void value_take_slick_greeter (GValue* value,
                               gpointer v_object);
VALA_EXTERN gpointer value_get_slick_greeter (const GValue* value);
VALA_EXTERN GType slick_greeter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SlickGreeter, slick_greeter_unref)
static gboolean ____lambda5_ (MenuBar* self);
static gboolean _____lambda5__gsource_func (gpointer self);
static void menu_bar_set_background (MenuBar* self,
                              Background* value);
static void menu_bar_set_accel_group (MenuBar* self,
                               GtkAccelGroup* value);
static void menu_bar_set_main_window (MenuBar* self,
                               MainWindow* value);
static GObject * menu_bar_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties);
VALA_EXTERN gchar* ug_settings_get_string (const gchar* key);
static gboolean _menu_bar_update_clock_gsource_func (gpointer self);
static void _menu_bar_on_power_device_added_upower_daemon_device_added (UPowerDaemon* _sender,
                                                                 const char* device,
                                                                 gpointer self);
static void _menu_bar_on_power_device_removed_upower_daemon_device_removed (UPowerDaemon* _sender,
                                                                     const char* device,
                                                                     gpointer self);
static void _menu_bar_on_power_device_changed_upower_daemon_device_changed (UPowerDaemon* _sender,
                                                                     const char* device,
                                                                     gpointer self);
static void _menu_bar_on_changed_upower_daemon_changed (UPowerDaemon* _sender,
                                                 gpointer self);
static void _menu_bar_on_sleeping_upower_daemon_sleeping (UPowerDaemon* _sender,
                                                   gpointer self);
static void _menu_bar_on_resuming_upower_daemon_resuming (UPowerDaemon* _sender,
                                                   gpointer self);
static gboolean _menu_bar_query_upower_daemon_gsource_func (gpointer self);
static void _menu_bar_cleanup_slick_greeter_starting_session (SlickGreeter* _sender,
                                                       gpointer self);
static void menu_bar_finalize (GObject * obj);
static GType menu_bar_get_type_once (void);
static void _vala_menu_bar_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec);
static void _vala_menu_bar_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const GDBusArgInfo _upower_daemon_dbus_arg_info_enumerate_devices_result = {-1, "result", "ao", NULL};
static const GDBusArgInfo * const _upower_daemon_dbus_arg_info_enumerate_devices_in[] = {NULL};
static const GDBusArgInfo * const _upower_daemon_dbus_arg_info_enumerate_devices_out[] = {&_upower_daemon_dbus_arg_info_enumerate_devices_result, NULL};
static const GDBusMethodInfo _upower_daemon_dbus_method_info_enumerate_devices = {-1, "EnumerateDevices", (GDBusArgInfo **) (&_upower_daemon_dbus_arg_info_enumerate_devices_in), (GDBusArgInfo **) (&_upower_daemon_dbus_arg_info_enumerate_devices_out), NULL};
static const GDBusMethodInfo * const _upower_daemon_dbus_method_info[] = {&_upower_daemon_dbus_method_info_enumerate_devices, NULL};
static const GDBusArgInfo _upower_daemon_dbus_arg_info_device_added_device = {-1, "device", "o", NULL};
static const GDBusArgInfo * const _upower_daemon_dbus_arg_info_device_added[] = {&_upower_daemon_dbus_arg_info_device_added_device, NULL};
static const GDBusSignalInfo _upower_daemon_dbus_signal_info_device_added = {-1, "DeviceAdded", (GDBusArgInfo **) (&_upower_daemon_dbus_arg_info_device_added), NULL};
static const GDBusArgInfo _upower_daemon_dbus_arg_info_device_removed_device = {-1, "device", "o", NULL};
static const GDBusArgInfo * const _upower_daemon_dbus_arg_info_device_removed[] = {&_upower_daemon_dbus_arg_info_device_removed_device, NULL};
static const GDBusSignalInfo _upower_daemon_dbus_signal_info_device_removed = {-1, "DeviceRemoved", (GDBusArgInfo **) (&_upower_daemon_dbus_arg_info_device_removed), NULL};
static const GDBusArgInfo _upower_daemon_dbus_arg_info_device_changed_device = {-1, "device", "o", NULL};
static const GDBusArgInfo * const _upower_daemon_dbus_arg_info_device_changed[] = {&_upower_daemon_dbus_arg_info_device_changed_device, NULL};
static const GDBusSignalInfo _upower_daemon_dbus_signal_info_device_changed = {-1, "DeviceChanged", (GDBusArgInfo **) (&_upower_daemon_dbus_arg_info_device_changed), NULL};
static const GDBusArgInfo * const _upower_daemon_dbus_arg_info_changed[] = {NULL};
static const GDBusSignalInfo _upower_daemon_dbus_signal_info_changed = {-1, "Changed", (GDBusArgInfo **) (&_upower_daemon_dbus_arg_info_changed), NULL};
static const GDBusArgInfo * const _upower_daemon_dbus_arg_info_sleeping[] = {NULL};
static const GDBusSignalInfo _upower_daemon_dbus_signal_info_sleeping = {-1, "Sleeping", (GDBusArgInfo **) (&_upower_daemon_dbus_arg_info_sleeping), NULL};
static const GDBusArgInfo * const _upower_daemon_dbus_arg_info_resuming[] = {NULL};
static const GDBusSignalInfo _upower_daemon_dbus_signal_info_resuming = {-1, "Resuming", (GDBusArgInfo **) (&_upower_daemon_dbus_arg_info_resuming), NULL};
static const GDBusSignalInfo * const _upower_daemon_dbus_signal_info[] = {&_upower_daemon_dbus_signal_info_device_added, &_upower_daemon_dbus_signal_info_device_removed, &_upower_daemon_dbus_signal_info_device_changed, &_upower_daemon_dbus_signal_info_changed, &_upower_daemon_dbus_signal_info_sleeping, &_upower_daemon_dbus_signal_info_resuming, NULL};
static const GDBusPropertyInfo _upower_daemon_dbus_property_info_daemon_version = {-1, "DaemonVersion", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_daemon_dbus_property_info_on_battery = {-1, "OnBattery", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_daemon_dbus_property_info_on_low_battery = {-1, "OnLowBattery", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_daemon_dbus_property_info_lid_is_present = {-1, "LidIsPresent", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_daemon_dbus_property_info_lid_is_closed = {-1, "LidIsClosed", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo * const _upower_daemon_dbus_property_info[] = {&_upower_daemon_dbus_property_info_daemon_version, &_upower_daemon_dbus_property_info_on_battery, &_upower_daemon_dbus_property_info_on_low_battery, &_upower_daemon_dbus_property_info_lid_is_present, &_upower_daemon_dbus_property_info_lid_is_closed, NULL};
static const GDBusInterfaceInfo _upower_daemon_dbus_interface_info = {-1, "org.freedesktop.UPower", (GDBusMethodInfo **) (&_upower_daemon_dbus_method_info), (GDBusSignalInfo **) (&_upower_daemon_dbus_signal_info), (GDBusPropertyInfo **) (&_upower_daemon_dbus_property_info), NULL};
static const GDBusInterfaceVTable _upower_daemon_dbus_interface_vtable = {upower_daemon_dbus_interface_method_call, upower_daemon_dbus_interface_get_property, upower_daemon_dbus_interface_set_property};
static const GDBusMethodInfo * const _upower_device_dbus_method_info[] = {NULL};
static const GDBusArgInfo * const _upower_device_dbus_arg_info_changed[] = {NULL};
static const GDBusSignalInfo _upower_device_dbus_signal_info_changed = {-1, "Changed", (GDBusArgInfo **) (&_upower_device_dbus_arg_info_changed), NULL};
static const GDBusSignalInfo * const _upower_device_dbus_signal_info[] = {&_upower_device_dbus_signal_info_changed, NULL};
static const GDBusPropertyInfo _upower_device_dbus_property_info_Type = {-1, "Type", "u", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_device_dbus_property_info_power_supply = {-1, "PowerSupply", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_device_dbus_property_info_online = {-1, "Online", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_device_dbus_property_info_is_present = {-1, "IsPresent", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_device_dbus_property_info_state = {-1, "State", "u", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_device_dbus_property_info_is_rechargeable = {-1, "IsRechargeable", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_device_dbus_property_info_capacity = {-1, "Capacity", "d", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_device_dbus_property_info_time_to_empty = {-1, "TimeToEmpty", "x", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_device_dbus_property_info_time_to_full = {-1, "TimeToFull", "x", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_device_dbus_property_info_energy = {-1, "Energy", "d", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_device_dbus_property_info_energy_empty = {-1, "EnergyEmpty", "d", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_device_dbus_property_info_energy_full = {-1, "EnergyFull", "d", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_device_dbus_property_info_energy_full_design = {-1, "EnergyFullDesign", "d", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_device_dbus_property_info_energy_rate = {-1, "EnergyRate", "d", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_device_dbus_property_info_percentage = {-1, "Percentage", "d", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_device_dbus_property_info_voltage = {-1, "Voltage", "d", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_device_dbus_property_info_technology = {-1, "Technology", "u", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_device_dbus_property_info_vendor = {-1, "Vendor", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_device_dbus_property_info_model = {-1, "Model", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _upower_device_dbus_property_info_serial = {-1, "Serial", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo * const _upower_device_dbus_property_info[] = {&_upower_device_dbus_property_info_Type, &_upower_device_dbus_property_info_power_supply, &_upower_device_dbus_property_info_online, &_upower_device_dbus_property_info_is_present, &_upower_device_dbus_property_info_state, &_upower_device_dbus_property_info_is_rechargeable, &_upower_device_dbus_property_info_capacity, &_upower_device_dbus_property_info_time_to_empty, &_upower_device_dbus_property_info_time_to_full, &_upower_device_dbus_property_info_energy, &_upower_device_dbus_property_info_energy_empty, &_upower_device_dbus_property_info_energy_full, &_upower_device_dbus_property_info_energy_full_design, &_upower_device_dbus_property_info_energy_rate, &_upower_device_dbus_property_info_percentage, &_upower_device_dbus_property_info_voltage, &_upower_device_dbus_property_info_technology, &_upower_device_dbus_property_info_vendor, &_upower_device_dbus_property_info_model, &_upower_device_dbus_property_info_serial, NULL};
static const GDBusInterfaceInfo _upower_device_dbus_interface_info = {-1, "org.freedesktop.UPower.Device", (GDBusMethodInfo **) (&_upower_device_dbus_method_info), (GDBusSignalInfo **) (&_upower_device_dbus_signal_info), (GDBusPropertyInfo **) (&_upower_device_dbus_property_info), NULL};
static const GDBusInterfaceVTable _upower_device_dbus_interface_vtable = {upower_device_dbus_interface_method_call, upower_device_dbus_interface_get_property, upower_device_dbus_interface_set_property};

char**
upower_daemon_enumerate_devices (UPowerDaemon* self,
                                 gint* result_length1,
                                 GError** error)
{
	UPowerDaemonIface* _iface_;
#line 31 "menubar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "menubar.vala"
	_iface_ = UPOWER_DAEMON_GET_INTERFACE (self);
#line 31 "menubar.vala"
	if (_iface_->enumerate_devices) {
#line 31 "menubar.vala"
		return _iface_->enumerate_devices (self, result_length1, error);
#line 696 "menubar.c"
	}
#line 31 "menubar.vala"
	return NULL;
#line 700 "menubar.c"
}

gchar*
upower_daemon_get_daemon_version (UPowerDaemon* self)
{
	UPowerDaemonIface* _iface_;
#line 33 "menubar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "menubar.vala"
	_iface_ = UPOWER_DAEMON_GET_INTERFACE (self);
#line 33 "menubar.vala"
	if (_iface_->get_daemon_version) {
#line 33 "menubar.vala"
		return _iface_->get_daemon_version (self);
#line 715 "menubar.c"
	}
#line 33 "menubar.vala"
	return NULL;
#line 719 "menubar.c"
}

gboolean
upower_daemon_get_on_battery (UPowerDaemon* self)
{
	UPowerDaemonIface* _iface_;
#line 36 "menubar.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 36 "menubar.vala"
	_iface_ = UPOWER_DAEMON_GET_INTERFACE (self);
#line 36 "menubar.vala"
	if (_iface_->get_on_battery) {
#line 36 "menubar.vala"
		return _iface_->get_on_battery (self);
#line 734 "menubar.c"
	}
#line 36 "menubar.vala"
	return FALSE;
#line 738 "menubar.c"
}

gboolean
upower_daemon_get_on_low_battery (UPowerDaemon* self)
{
	UPowerDaemonIface* _iface_;
#line 37 "menubar.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 37 "menubar.vala"
	_iface_ = UPOWER_DAEMON_GET_INTERFACE (self);
#line 37 "menubar.vala"
	if (_iface_->get_on_low_battery) {
#line 37 "menubar.vala"
		return _iface_->get_on_low_battery (self);
#line 753 "menubar.c"
	}
#line 37 "menubar.vala"
	return FALSE;
#line 757 "menubar.c"
}

gboolean
upower_daemon_get_lid_is_present (UPowerDaemon* self)
{
	UPowerDaemonIface* _iface_;
#line 38 "menubar.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 38 "menubar.vala"
	_iface_ = UPOWER_DAEMON_GET_INTERFACE (self);
#line 38 "menubar.vala"
	if (_iface_->get_lid_is_present) {
#line 38 "menubar.vala"
		return _iface_->get_lid_is_present (self);
#line 772 "menubar.c"
	}
#line 38 "menubar.vala"
	return FALSE;
#line 776 "menubar.c"
}

gboolean
upower_daemon_get_lid_is_closed (UPowerDaemon* self)
{
	UPowerDaemonIface* _iface_;
#line 39 "menubar.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 39 "menubar.vala"
	_iface_ = UPOWER_DAEMON_GET_INTERFACE (self);
#line 39 "menubar.vala"
	if (_iface_->get_lid_is_closed) {
#line 39 "menubar.vala"
		return _iface_->get_lid_is_closed (self);
#line 791 "menubar.c"
	}
#line 39 "menubar.vala"
	return FALSE;
#line 795 "menubar.c"
}

static void
upower_daemon_default_init (UPowerDaemonIface * iface,
                            gpointer iface_data)
{
#line 24 "menubar.vala"
	upower_daemon_signals[UPOWER_DAEMON_DEVICE_ADDED_SIGNAL] = g_signal_new ("device-added", UPOWER_TYPE_DAEMON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 24 "menubar.vala"
	upower_daemon_signals[UPOWER_DAEMON_DEVICE_REMOVED_SIGNAL] = g_signal_new ("device-removed", UPOWER_TYPE_DAEMON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 24 "menubar.vala"
	upower_daemon_signals[UPOWER_DAEMON_DEVICE_CHANGED_SIGNAL] = g_signal_new ("device-changed", UPOWER_TYPE_DAEMON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 24 "menubar.vala"
	upower_daemon_signals[UPOWER_DAEMON_CHANGED_SIGNAL] = g_signal_new ("changed", UPOWER_TYPE_DAEMON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 24 "menubar.vala"
	upower_daemon_signals[UPOWER_DAEMON_SLEEPING_SIGNAL] = g_signal_new ("sleeping", UPOWER_TYPE_DAEMON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 24 "menubar.vala"
	upower_daemon_signals[UPOWER_DAEMON_RESUMING_SIGNAL] = g_signal_new ("resuming", UPOWER_TYPE_DAEMON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 814 "menubar.c"
}

static GType
upower_daemon_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (UPowerDaemonIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) upower_daemon_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType upower_daemon_type_id;
	upower_daemon_type_id = g_type_register_static (G_TYPE_INTERFACE, "UPowerDaemon", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (upower_daemon_type_id, G_TYPE_OBJECT);
	g_type_set_qdata (upower_daemon_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) upower_daemon_proxy_get_type);
	g_type_set_qdata (upower_daemon_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.freedesktop.UPower");
	g_type_set_qdata (upower_daemon_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_upower_daemon_dbus_interface_info));
	g_type_set_qdata (upower_daemon_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) upower_daemon_register_object);
	return upower_daemon_type_id;
}

GType
upower_daemon_get_type (void)
{
	static volatile gsize upower_daemon_type_id__volatile = 0;
	if (g_once_init_enter (&upower_daemon_type_id__volatile)) {
		GType upower_daemon_type_id;
		upower_daemon_type_id = upower_daemon_get_type_once ();
		g_once_init_leave (&upower_daemon_type_id__volatile, upower_daemon_type_id);
	}
	return upower_daemon_type_id__volatile;
}

G_DEFINE_TYPE_EXTENDED (UPowerDaemonProxy, upower_daemon_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (UPOWER_TYPE_DAEMON, upower_daemon_proxy_upower_daemon_interface_init) )
static void
upower_daemon_proxy_class_init (UPowerDaemonProxyClass* klass)
{
	G_DBUS_PROXY_CLASS (klass)->g_signal = upower_daemon_proxy_g_signal;
}

static void
_dbus_handle_upower_daemon_device_added (UPowerDaemon* self,
                                         GVariant* parameters)
{
	GVariantIter _arguments_iter;
	char* device = NULL;
	GVariant* _tmp1_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp1_ = g_variant_iter_next_value (&_arguments_iter);
	device = g_variant_dup_string (_tmp1_, NULL);
	g_variant_unref (_tmp1_);
	g_signal_emit_by_name (self, "device-added", device);
	_g_free0 (device);
}

static void
_dbus_handle_upower_daemon_device_removed (UPowerDaemon* self,
                                           GVariant* parameters)
{
	GVariantIter _arguments_iter;
	char* device = NULL;
	GVariant* _tmp2_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp2_ = g_variant_iter_next_value (&_arguments_iter);
	device = g_variant_dup_string (_tmp2_, NULL);
	g_variant_unref (_tmp2_);
	g_signal_emit_by_name (self, "device-removed", device);
	_g_free0 (device);
}

static void
_dbus_handle_upower_daemon_device_changed (UPowerDaemon* self,
                                           GVariant* parameters)
{
	GVariantIter _arguments_iter;
	char* device = NULL;
	GVariant* _tmp3_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp3_ = g_variant_iter_next_value (&_arguments_iter);
	device = g_variant_dup_string (_tmp3_, NULL);
	g_variant_unref (_tmp3_);
	g_signal_emit_by_name (self, "device-changed", device);
	_g_free0 (device);
}

static void
_dbus_handle_upower_daemon_changed (UPowerDaemon* self,
                                    GVariant* parameters)
{
	GVariantIter _arguments_iter;
	g_variant_iter_init (&_arguments_iter, parameters);
	g_signal_emit_by_name (self, "changed");
}

static void
_dbus_handle_upower_daemon_sleeping (UPowerDaemon* self,
                                     GVariant* parameters)
{
	GVariantIter _arguments_iter;
	g_variant_iter_init (&_arguments_iter, parameters);
	g_signal_emit_by_name (self, "sleeping");
}

static void
_dbus_handle_upower_daemon_resuming (UPowerDaemon* self,
                                     GVariant* parameters)
{
	GVariantIter _arguments_iter;
	g_variant_iter_init (&_arguments_iter, parameters);
	g_signal_emit_by_name (self, "resuming");
}

static void
upower_daemon_proxy_g_signal (GDBusProxy* proxy,
                              const gchar* sender_name,
                              const gchar* signal_name,
                              GVariant* parameters)
{
	if (strcmp (signal_name, "DeviceAdded") == 0) {
		_dbus_handle_upower_daemon_device_added ((UPowerDaemon*) proxy, parameters);
	} else if (strcmp (signal_name, "DeviceRemoved") == 0) {
		_dbus_handle_upower_daemon_device_removed ((UPowerDaemon*) proxy, parameters);
	} else if (strcmp (signal_name, "DeviceChanged") == 0) {
		_dbus_handle_upower_daemon_device_changed ((UPowerDaemon*) proxy, parameters);
	} else if (strcmp (signal_name, "Changed") == 0) {
		_dbus_handle_upower_daemon_changed ((UPowerDaemon*) proxy, parameters);
	} else if (strcmp (signal_name, "Sleeping") == 0) {
		_dbus_handle_upower_daemon_sleeping ((UPowerDaemon*) proxy, parameters);
	} else if (strcmp (signal_name, "Resuming") == 0) {
		_dbus_handle_upower_daemon_resuming ((UPowerDaemon*) proxy, parameters);
	}
}

static void
upower_daemon_proxy_init (UPowerDaemonProxy* self)
{
	g_dbus_proxy_set_interface_info (G_DBUS_PROXY (self), (GDBusInterfaceInfo *) (&_upower_daemon_dbus_interface_info));
}

static char**
upower_daemon_proxy_enumerate_devices (UPowerDaemon* self,
                                       gint* result_length1,
                                       GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	char** _result = NULL;
	gint _result_length1;
	GVariant* _tmp4_;
	char** _tmp5_;
	gint _tmp5__length;
	gint _tmp5__size;
	gint _tmp5__length1;
	GVariantIter _tmp6_;
	GVariant* _tmp7_;
	G_DBUS_ERROR;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.freedesktop.UPower", "EnumerateDevices");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_result_length1 = 0;
	_tmp4_ = g_variant_iter_next_value (&_reply_iter);
	_tmp5_ = g_new (char*, 5);
	_tmp5__length = 0;
	_tmp5__size = 4;
	_tmp5__length1 = 0;
	g_variant_iter_init (&_tmp6_, _tmp4_);
	for (; (_tmp7_ = g_variant_iter_next_value (&_tmp6_)) != NULL; _tmp5__length1++) {
		if (_tmp5__size == _tmp5__length) {
			_tmp5__size = 2 * _tmp5__size;
			_tmp5_ = g_renew (char*, _tmp5_, _tmp5__size + 1);
		}
		_tmp5_[_tmp5__length++] = g_variant_dup_string (_tmp7_, NULL);
		g_variant_unref (_tmp7_);
	}
	_result_length1 = _tmp5__length1;
	_tmp5_[_tmp5__length] = NULL;
	_result = _tmp5_;
	g_variant_unref (_tmp4_);
	*result_length1 = _result_length1;
	g_object_unref (_reply_message);
	return _result;
}

static gchar*
upower_daemon_dbus_proxy_get_daemon_version (UPowerDaemon* self)
{
	GVariant *_inner_reply;
	gchar* _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "DaemonVersion");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("DaemonVersion"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			return NULL;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_dup_string (_inner_reply, NULL);
	g_variant_unref (_inner_reply);
	return _result;
}

static gboolean
upower_daemon_dbus_proxy_get_on_battery (UPowerDaemon* self)
{
	GVariant *_inner_reply;
	gboolean _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "OnBattery");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("OnBattery"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gboolean _tmp8_ = FALSE;
			return _tmp8_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_boolean (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static gboolean
upower_daemon_dbus_proxy_get_on_low_battery (UPowerDaemon* self)
{
	GVariant *_inner_reply;
	gboolean _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "OnLowBattery");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("OnLowBattery"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gboolean _tmp9_ = FALSE;
			return _tmp9_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_boolean (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static gboolean
upower_daemon_dbus_proxy_get_lid_is_present (UPowerDaemon* self)
{
	GVariant *_inner_reply;
	gboolean _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "LidIsPresent");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("LidIsPresent"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gboolean _tmp10_ = FALSE;
			return _tmp10_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_boolean (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static gboolean
upower_daemon_dbus_proxy_get_lid_is_closed (UPowerDaemon* self)
{
	GVariant *_inner_reply;
	gboolean _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "LidIsClosed");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("LidIsClosed"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gboolean _tmp11_ = FALSE;
			return _tmp11_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_boolean (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static void
upower_daemon_proxy_upower_daemon_interface_init (UPowerDaemonIface* iface)
{
	iface->enumerate_devices = upower_daemon_proxy_enumerate_devices;
	iface->get_daemon_version = upower_daemon_dbus_proxy_get_daemon_version;
	iface->get_on_battery = upower_daemon_dbus_proxy_get_on_battery;
	iface->get_on_low_battery = upower_daemon_dbus_proxy_get_on_low_battery;
	iface->get_lid_is_present = upower_daemon_dbus_proxy_get_lid_is_present;
	iface->get_lid_is_closed = upower_daemon_dbus_proxy_get_lid_is_closed;
}

static void
_dbus_upower_daemon_enumerate_devices (UPowerDaemon* self,
                                       GVariant* _parameters_,
                                       GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	char** result;
	gint result_length1 = 0;
	char** _tmp12_;
	GVariantBuilder _tmp13_;
	gint _tmp14_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	result = upower_daemon_enumerate_devices (self, &result_length1, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp12_ = result;
	g_variant_builder_init (&_tmp13_, G_VARIANT_TYPE ("ao"));
	for (_tmp14_ = 0; _tmp14_ < result_length1; _tmp14_++) {
		g_variant_builder_add_value (&_tmp13_, g_variant_new_object_path (*_tmp12_));
		_tmp12_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp13_));
	result = (_vala_array_free (result, result_length1, (GDestroyNotify) g_free), NULL);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
upower_daemon_dbus_interface_method_call (GDBusConnection* connection,
                                          const gchar* sender,
                                          const gchar* object_path,
                                          const gchar* interface_name,
                                          const gchar* method_name,
                                          GVariant* parameters,
                                          GDBusMethodInvocation* invocation,
                                          gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "EnumerateDevices") == 0) {
		_dbus_upower_daemon_enumerate_devices (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}

static GVariant*
_dbus_upower_daemon_get_daemon_version (UPowerDaemon* self)
{
	gchar* result;
	GVariant* _reply;
	result = upower_daemon_get_daemon_version (self);
	_reply = g_variant_new_string (result);
	_g_free0 (result);
	return _reply;
}

static GVariant*
_dbus_upower_daemon_get_on_battery (UPowerDaemon* self)
{
	gboolean result;
	GVariant* _reply;
	result = upower_daemon_get_on_battery (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}

static GVariant*
_dbus_upower_daemon_get_on_low_battery (UPowerDaemon* self)
{
	gboolean result;
	GVariant* _reply;
	result = upower_daemon_get_on_low_battery (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}

static GVariant*
_dbus_upower_daemon_get_lid_is_present (UPowerDaemon* self)
{
	gboolean result;
	GVariant* _reply;
	result = upower_daemon_get_lid_is_present (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}

static GVariant*
_dbus_upower_daemon_get_lid_is_closed (UPowerDaemon* self)
{
	gboolean result;
	GVariant* _reply;
	result = upower_daemon_get_lid_is_closed (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}

static GVariant*
upower_daemon_dbus_interface_get_property (GDBusConnection* connection,
                                           const gchar* sender,
                                           const gchar* object_path,
                                           const gchar* interface_name,
                                           const gchar* property_name,
                                           GError** error,
                                           gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "DaemonVersion") == 0) {
		return _dbus_upower_daemon_get_daemon_version (object);
	} else if (strcmp (property_name, "OnBattery") == 0) {
		return _dbus_upower_daemon_get_on_battery (object);
	} else if (strcmp (property_name, "OnLowBattery") == 0) {
		return _dbus_upower_daemon_get_on_low_battery (object);
	} else if (strcmp (property_name, "LidIsPresent") == 0) {
		return _dbus_upower_daemon_get_lid_is_present (object);
	} else if (strcmp (property_name, "LidIsClosed") == 0) {
		return _dbus_upower_daemon_get_lid_is_closed (object);
	}
	return NULL;
}

static gboolean
upower_daemon_dbus_interface_set_property (GDBusConnection* connection,
                                           const gchar* sender,
                                           const gchar* object_path,
                                           const gchar* interface_name,
                                           const gchar* property_name,
                                           GVariant* value,
                                           GError** error,
                                           gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

static void
_dbus_upower_daemon_device_added (GObject* _sender,
                                  const char* device,
                                  gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_object_path (device));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.freedesktop.UPower", "DeviceAdded", _arguments, NULL);
}

static void
_dbus_upower_daemon_device_removed (GObject* _sender,
                                    const char* device,
                                    gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_object_path (device));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.freedesktop.UPower", "DeviceRemoved", _arguments, NULL);
}

static void
_dbus_upower_daemon_device_changed (GObject* _sender,
                                    const char* device,
                                    gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_object_path (device));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.freedesktop.UPower", "DeviceChanged", _arguments, NULL);
}

static void
_dbus_upower_daemon_changed (GObject* _sender,
                             gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.freedesktop.UPower", "Changed", _arguments, NULL);
}

static void
_dbus_upower_daemon_sleeping (GObject* _sender,
                              gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.freedesktop.UPower", "Sleeping", _arguments, NULL);
}

static void
_dbus_upower_daemon_resuming (GObject* _sender,
                              gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.freedesktop.UPower", "Resuming", _arguments, NULL);
}

guint
upower_daemon_register_object (gpointer object,
                               GDBusConnection* connection,
                               const gchar* path,
                               GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_upower_daemon_dbus_interface_info), &_upower_daemon_dbus_interface_vtable, data, _upower_daemon_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "device-added", (GCallback) _dbus_upower_daemon_device_added, data);
	g_signal_connect (object, "device-removed", (GCallback) _dbus_upower_daemon_device_removed, data);
	g_signal_connect (object, "device-changed", (GCallback) _dbus_upower_daemon_device_changed, data);
	g_signal_connect (object, "changed", (GCallback) _dbus_upower_daemon_changed, data);
	g_signal_connect (object, "sleeping", (GCallback) _dbus_upower_daemon_sleeping, data);
	g_signal_connect (object, "resuming", (GCallback) _dbus_upower_daemon_resuming, data);
	return result;
}

static void
_upower_daemon_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_upower_daemon_device_added, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_upower_daemon_device_removed, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_upower_daemon_device_changed, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_upower_daemon_changed, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_upower_daemon_sleeping, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_upower_daemon_resuming, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

guint
upower_device_get_Type (UPowerDevice* self)
{
	UPowerDeviceIface* _iface_;
#line 53 "menubar.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 53 "menubar.vala"
	_iface_ = UPOWER_DEVICE_GET_INTERFACE (self);
#line 53 "menubar.vala"
	if (_iface_->get_Type) {
#line 53 "menubar.vala"
		return _iface_->get_Type (self);
#line 1460 "menubar.c"
	}
#line 53 "menubar.vala"
	return 0U;
#line 1464 "menubar.c"
}

gboolean
upower_device_get_power_supply (UPowerDevice* self)
{
	UPowerDeviceIface* _iface_;
#line 54 "menubar.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 54 "menubar.vala"
	_iface_ = UPOWER_DEVICE_GET_INTERFACE (self);
#line 54 "menubar.vala"
	if (_iface_->get_power_supply) {
#line 54 "menubar.vala"
		return _iface_->get_power_supply (self);
#line 1479 "menubar.c"
	}
#line 54 "menubar.vala"
	return FALSE;
#line 1483 "menubar.c"
}

gboolean
upower_device_get_online (UPowerDevice* self)
{
	UPowerDeviceIface* _iface_;
#line 55 "menubar.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 55 "menubar.vala"
	_iface_ = UPOWER_DEVICE_GET_INTERFACE (self);
#line 55 "menubar.vala"
	if (_iface_->get_online) {
#line 55 "menubar.vala"
		return _iface_->get_online (self);
#line 1498 "menubar.c"
	}
#line 55 "menubar.vala"
	return FALSE;
#line 1502 "menubar.c"
}

gboolean
upower_device_get_is_present (UPowerDevice* self)
{
	UPowerDeviceIface* _iface_;
#line 56 "menubar.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 56 "menubar.vala"
	_iface_ = UPOWER_DEVICE_GET_INTERFACE (self);
#line 56 "menubar.vala"
	if (_iface_->get_is_present) {
#line 56 "menubar.vala"
		return _iface_->get_is_present (self);
#line 1517 "menubar.c"
	}
#line 56 "menubar.vala"
	return FALSE;
#line 1521 "menubar.c"
}

guint
upower_device_get_state (UPowerDevice* self)
{
	UPowerDeviceIface* _iface_;
#line 57 "menubar.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 57 "menubar.vala"
	_iface_ = UPOWER_DEVICE_GET_INTERFACE (self);
#line 57 "menubar.vala"
	if (_iface_->get_state) {
#line 57 "menubar.vala"
		return _iface_->get_state (self);
#line 1536 "menubar.c"
	}
#line 57 "menubar.vala"
	return 0U;
#line 1540 "menubar.c"
}

gboolean
upower_device_get_is_rechargeable (UPowerDevice* self)
{
	UPowerDeviceIface* _iface_;
#line 58 "menubar.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 58 "menubar.vala"
	_iface_ = UPOWER_DEVICE_GET_INTERFACE (self);
#line 58 "menubar.vala"
	if (_iface_->get_is_rechargeable) {
#line 58 "menubar.vala"
		return _iface_->get_is_rechargeable (self);
#line 1555 "menubar.c"
	}
#line 58 "menubar.vala"
	return FALSE;
#line 1559 "menubar.c"
}

gdouble
upower_device_get_capacity (UPowerDevice* self)
{
	UPowerDeviceIface* _iface_;
#line 59 "menubar.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 59 "menubar.vala"
	_iface_ = UPOWER_DEVICE_GET_INTERFACE (self);
#line 59 "menubar.vala"
	if (_iface_->get_capacity) {
#line 59 "menubar.vala"
		return _iface_->get_capacity (self);
#line 1574 "menubar.c"
	}
#line 59 "menubar.vala"
	return -1.0;
#line 1578 "menubar.c"
}

gint64
upower_device_get_time_to_empty (UPowerDevice* self)
{
	UPowerDeviceIface* _iface_;
#line 60 "menubar.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 60 "menubar.vala"
	_iface_ = UPOWER_DEVICE_GET_INTERFACE (self);
#line 60 "menubar.vala"
	if (_iface_->get_time_to_empty) {
#line 60 "menubar.vala"
		return _iface_->get_time_to_empty (self);
#line 1593 "menubar.c"
	}
#line 60 "menubar.vala"
	return -1LL;
#line 1597 "menubar.c"
}

gint64
upower_device_get_time_to_full (UPowerDevice* self)
{
	UPowerDeviceIface* _iface_;
#line 61 "menubar.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 61 "menubar.vala"
	_iface_ = UPOWER_DEVICE_GET_INTERFACE (self);
#line 61 "menubar.vala"
	if (_iface_->get_time_to_full) {
#line 61 "menubar.vala"
		return _iface_->get_time_to_full (self);
#line 1612 "menubar.c"
	}
#line 61 "menubar.vala"
	return -1LL;
#line 1616 "menubar.c"
}

gdouble
upower_device_get_energy (UPowerDevice* self)
{
	UPowerDeviceIface* _iface_;
#line 62 "menubar.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 62 "menubar.vala"
	_iface_ = UPOWER_DEVICE_GET_INTERFACE (self);
#line 62 "menubar.vala"
	if (_iface_->get_energy) {
#line 62 "menubar.vala"
		return _iface_->get_energy (self);
#line 1631 "menubar.c"
	}
#line 62 "menubar.vala"
	return -1.0;
#line 1635 "menubar.c"
}

gdouble
upower_device_get_energy_empty (UPowerDevice* self)
{
	UPowerDeviceIface* _iface_;
#line 63 "menubar.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 63 "menubar.vala"
	_iface_ = UPOWER_DEVICE_GET_INTERFACE (self);
#line 63 "menubar.vala"
	if (_iface_->get_energy_empty) {
#line 63 "menubar.vala"
		return _iface_->get_energy_empty (self);
#line 1650 "menubar.c"
	}
#line 63 "menubar.vala"
	return -1.0;
#line 1654 "menubar.c"
}

gdouble
upower_device_get_energy_full (UPowerDevice* self)
{
	UPowerDeviceIface* _iface_;
#line 64 "menubar.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 64 "menubar.vala"
	_iface_ = UPOWER_DEVICE_GET_INTERFACE (self);
#line 64 "menubar.vala"
	if (_iface_->get_energy_full) {
#line 64 "menubar.vala"
		return _iface_->get_energy_full (self);
#line 1669 "menubar.c"
	}
#line 64 "menubar.vala"
	return -1.0;
#line 1673 "menubar.c"
}

gdouble
upower_device_get_energy_full_design (UPowerDevice* self)
{
	UPowerDeviceIface* _iface_;
#line 65 "menubar.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 65 "menubar.vala"
	_iface_ = UPOWER_DEVICE_GET_INTERFACE (self);
#line 65 "menubar.vala"
	if (_iface_->get_energy_full_design) {
#line 65 "menubar.vala"
		return _iface_->get_energy_full_design (self);
#line 1688 "menubar.c"
	}
#line 65 "menubar.vala"
	return -1.0;
#line 1692 "menubar.c"
}

gdouble
upower_device_get_energy_rate (UPowerDevice* self)
{
	UPowerDeviceIface* _iface_;
#line 66 "menubar.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 66 "menubar.vala"
	_iface_ = UPOWER_DEVICE_GET_INTERFACE (self);
#line 66 "menubar.vala"
	if (_iface_->get_energy_rate) {
#line 66 "menubar.vala"
		return _iface_->get_energy_rate (self);
#line 1707 "menubar.c"
	}
#line 66 "menubar.vala"
	return -1.0;
#line 1711 "menubar.c"
}

gdouble
upower_device_get_percentage (UPowerDevice* self)
{
	UPowerDeviceIface* _iface_;
#line 67 "menubar.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 67 "menubar.vala"
	_iface_ = UPOWER_DEVICE_GET_INTERFACE (self);
#line 67 "menubar.vala"
	if (_iface_->get_percentage) {
#line 67 "menubar.vala"
		return _iface_->get_percentage (self);
#line 1726 "menubar.c"
	}
#line 67 "menubar.vala"
	return -1.0;
#line 1730 "menubar.c"
}

gdouble
upower_device_get_voltage (UPowerDevice* self)
{
	UPowerDeviceIface* _iface_;
#line 68 "menubar.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 68 "menubar.vala"
	_iface_ = UPOWER_DEVICE_GET_INTERFACE (self);
#line 68 "menubar.vala"
	if (_iface_->get_voltage) {
#line 68 "menubar.vala"
		return _iface_->get_voltage (self);
#line 1745 "menubar.c"
	}
#line 68 "menubar.vala"
	return -1.0;
#line 1749 "menubar.c"
}

guint
upower_device_get_technology (UPowerDevice* self)
{
	UPowerDeviceIface* _iface_;
#line 69 "menubar.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 69 "menubar.vala"
	_iface_ = UPOWER_DEVICE_GET_INTERFACE (self);
#line 69 "menubar.vala"
	if (_iface_->get_technology) {
#line 69 "menubar.vala"
		return _iface_->get_technology (self);
#line 1764 "menubar.c"
	}
#line 69 "menubar.vala"
	return 0U;
#line 1768 "menubar.c"
}

gchar*
upower_device_get_vendor (UPowerDevice* self)
{
	UPowerDeviceIface* _iface_;
#line 70 "menubar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 70 "menubar.vala"
	_iface_ = UPOWER_DEVICE_GET_INTERFACE (self);
#line 70 "menubar.vala"
	if (_iface_->get_vendor) {
#line 70 "menubar.vala"
		return _iface_->get_vendor (self);
#line 1783 "menubar.c"
	}
#line 70 "menubar.vala"
	return NULL;
#line 1787 "menubar.c"
}

gchar*
upower_device_get_model (UPowerDevice* self)
{
	UPowerDeviceIface* _iface_;
#line 71 "menubar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 71 "menubar.vala"
	_iface_ = UPOWER_DEVICE_GET_INTERFACE (self);
#line 71 "menubar.vala"
	if (_iface_->get_model) {
#line 71 "menubar.vala"
		return _iface_->get_model (self);
#line 1802 "menubar.c"
	}
#line 71 "menubar.vala"
	return NULL;
#line 1806 "menubar.c"
}

gchar*
upower_device_get_serial (UPowerDevice* self)
{
	UPowerDeviceIface* _iface_;
#line 72 "menubar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 72 "menubar.vala"
	_iface_ = UPOWER_DEVICE_GET_INTERFACE (self);
#line 72 "menubar.vala"
	if (_iface_->get_serial) {
#line 72 "menubar.vala"
		return _iface_->get_serial (self);
#line 1821 "menubar.c"
	}
#line 72 "menubar.vala"
	return NULL;
#line 1825 "menubar.c"
}

static void
upower_device_default_init (UPowerDeviceIface * iface,
                            gpointer iface_data)
{
#line 50 "menubar.vala"
	upower_device_signals[UPOWER_DEVICE_CHANGED_SIGNAL] = g_signal_new ("changed", UPOWER_TYPE_DEVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1834 "menubar.c"
}

static GType
upower_device_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (UPowerDeviceIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) upower_device_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType upower_device_type_id;
	upower_device_type_id = g_type_register_static (G_TYPE_INTERFACE, "UPowerDevice", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (upower_device_type_id, G_TYPE_OBJECT);
	g_type_set_qdata (upower_device_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) upower_device_proxy_get_type);
	g_type_set_qdata (upower_device_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.freedesktop.UPower.Device");
	g_type_set_qdata (upower_device_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_upower_device_dbus_interface_info));
	g_type_set_qdata (upower_device_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) upower_device_register_object);
	return upower_device_type_id;
}

GType
upower_device_get_type (void)
{
	static volatile gsize upower_device_type_id__volatile = 0;
	if (g_once_init_enter (&upower_device_type_id__volatile)) {
		GType upower_device_type_id;
		upower_device_type_id = upower_device_get_type_once ();
		g_once_init_leave (&upower_device_type_id__volatile, upower_device_type_id);
	}
	return upower_device_type_id__volatile;
}

G_DEFINE_TYPE_EXTENDED (UPowerDeviceProxy, upower_device_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (UPOWER_TYPE_DEVICE, upower_device_proxy_upower_device_interface_init) )
static void
upower_device_proxy_class_init (UPowerDeviceProxyClass* klass)
{
	G_DBUS_PROXY_CLASS (klass)->g_signal = upower_device_proxy_g_signal;
}

static void
_dbus_handle_upower_device_changed (UPowerDevice* self,
                                    GVariant* parameters)
{
	GVariantIter _arguments_iter;
	g_variant_iter_init (&_arguments_iter, parameters);
	g_signal_emit_by_name (self, "changed");
}

static void
upower_device_proxy_g_signal (GDBusProxy* proxy,
                              const gchar* sender_name,
                              const gchar* signal_name,
                              GVariant* parameters)
{
	if (strcmp (signal_name, "Changed") == 0) {
		_dbus_handle_upower_device_changed ((UPowerDevice*) proxy, parameters);
	}
}

static void
upower_device_proxy_init (UPowerDeviceProxy* self)
{
	g_dbus_proxy_set_interface_info (G_DBUS_PROXY (self), (GDBusInterfaceInfo *) (&_upower_device_dbus_interface_info));
}

static guint
upower_device_dbus_proxy_get_Type (UPowerDevice* self)
{
	GVariant *_inner_reply;
	guint _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Type");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Type"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			guint _tmp15_ = 0U;
			return _tmp15_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_uint32 (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static gboolean
upower_device_dbus_proxy_get_power_supply (UPowerDevice* self)
{
	GVariant *_inner_reply;
	gboolean _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "PowerSupply");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("PowerSupply"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gboolean _tmp16_ = FALSE;
			return _tmp16_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_boolean (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static gboolean
upower_device_dbus_proxy_get_online (UPowerDevice* self)
{
	GVariant *_inner_reply;
	gboolean _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Online");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Online"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gboolean _tmp17_ = FALSE;
			return _tmp17_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_boolean (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static gboolean
upower_device_dbus_proxy_get_is_present (UPowerDevice* self)
{
	GVariant *_inner_reply;
	gboolean _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "IsPresent");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("IsPresent"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gboolean _tmp18_ = FALSE;
			return _tmp18_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_boolean (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static guint
upower_device_dbus_proxy_get_state (UPowerDevice* self)
{
	GVariant *_inner_reply;
	guint _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "State");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("State"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			guint _tmp19_ = 0U;
			return _tmp19_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_uint32 (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static gboolean
upower_device_dbus_proxy_get_is_rechargeable (UPowerDevice* self)
{
	GVariant *_inner_reply;
	gboolean _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "IsRechargeable");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("IsRechargeable"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gboolean _tmp20_ = FALSE;
			return _tmp20_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_boolean (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static gdouble
upower_device_dbus_proxy_get_capacity (UPowerDevice* self)
{
	GVariant *_inner_reply;
	gdouble _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Capacity");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Capacity"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gdouble _tmp21_ = 0.0;
			return _tmp21_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_double (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static gint64
upower_device_dbus_proxy_get_time_to_empty (UPowerDevice* self)
{
	GVariant *_inner_reply;
	gint64 _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "TimeToEmpty");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("TimeToEmpty"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gint64 _tmp22_ = 0LL;
			return _tmp22_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_int64 (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static gint64
upower_device_dbus_proxy_get_time_to_full (UPowerDevice* self)
{
	GVariant *_inner_reply;
	gint64 _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "TimeToFull");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("TimeToFull"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gint64 _tmp23_ = 0LL;
			return _tmp23_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_int64 (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static gdouble
upower_device_dbus_proxy_get_energy (UPowerDevice* self)
{
	GVariant *_inner_reply;
	gdouble _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Energy");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Energy"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gdouble _tmp24_ = 0.0;
			return _tmp24_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_double (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static gdouble
upower_device_dbus_proxy_get_energy_empty (UPowerDevice* self)
{
	GVariant *_inner_reply;
	gdouble _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "EnergyEmpty");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("EnergyEmpty"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gdouble _tmp25_ = 0.0;
			return _tmp25_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_double (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static gdouble
upower_device_dbus_proxy_get_energy_full (UPowerDevice* self)
{
	GVariant *_inner_reply;
	gdouble _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "EnergyFull");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("EnergyFull"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gdouble _tmp26_ = 0.0;
			return _tmp26_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_double (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static gdouble
upower_device_dbus_proxy_get_energy_full_design (UPowerDevice* self)
{
	GVariant *_inner_reply;
	gdouble _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "EnergyFullDesign");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("EnergyFullDesign"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gdouble _tmp27_ = 0.0;
			return _tmp27_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_double (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static gdouble
upower_device_dbus_proxy_get_energy_rate (UPowerDevice* self)
{
	GVariant *_inner_reply;
	gdouble _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "EnergyRate");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("EnergyRate"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gdouble _tmp28_ = 0.0;
			return _tmp28_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_double (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static gdouble
upower_device_dbus_proxy_get_percentage (UPowerDevice* self)
{
	GVariant *_inner_reply;
	gdouble _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Percentage");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Percentage"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gdouble _tmp29_ = 0.0;
			return _tmp29_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_double (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static gdouble
upower_device_dbus_proxy_get_voltage (UPowerDevice* self)
{
	GVariant *_inner_reply;
	gdouble _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Voltage");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Voltage"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gdouble _tmp30_ = 0.0;
			return _tmp30_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_double (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static guint
upower_device_dbus_proxy_get_technology (UPowerDevice* self)
{
	GVariant *_inner_reply;
	guint _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Technology");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Technology"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			guint _tmp31_ = 0U;
			return _tmp31_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_uint32 (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static gchar*
upower_device_dbus_proxy_get_vendor (UPowerDevice* self)
{
	GVariant *_inner_reply;
	gchar* _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Vendor");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Vendor"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			return NULL;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_dup_string (_inner_reply, NULL);
	g_variant_unref (_inner_reply);
	return _result;
}

static gchar*
upower_device_dbus_proxy_get_model (UPowerDevice* self)
{
	GVariant *_inner_reply;
	gchar* _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Model");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Model"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			return NULL;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_dup_string (_inner_reply, NULL);
	g_variant_unref (_inner_reply);
	return _result;
}

static gchar*
upower_device_dbus_proxy_get_serial (UPowerDevice* self)
{
	GVariant *_inner_reply;
	gchar* _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Serial");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.UPower.Device"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Serial"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			return NULL;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_dup_string (_inner_reply, NULL);
	g_variant_unref (_inner_reply);
	return _result;
}

static void
upower_device_proxy_upower_device_interface_init (UPowerDeviceIface* iface)
{
	iface->get_Type = upower_device_dbus_proxy_get_Type;
	iface->get_power_supply = upower_device_dbus_proxy_get_power_supply;
	iface->get_online = upower_device_dbus_proxy_get_online;
	iface->get_is_present = upower_device_dbus_proxy_get_is_present;
	iface->get_state = upower_device_dbus_proxy_get_state;
	iface->get_is_rechargeable = upower_device_dbus_proxy_get_is_rechargeable;
	iface->get_capacity = upower_device_dbus_proxy_get_capacity;
	iface->get_time_to_empty = upower_device_dbus_proxy_get_time_to_empty;
	iface->get_time_to_full = upower_device_dbus_proxy_get_time_to_full;
	iface->get_energy = upower_device_dbus_proxy_get_energy;
	iface->get_energy_empty = upower_device_dbus_proxy_get_energy_empty;
	iface->get_energy_full = upower_device_dbus_proxy_get_energy_full;
	iface->get_energy_full_design = upower_device_dbus_proxy_get_energy_full_design;
	iface->get_energy_rate = upower_device_dbus_proxy_get_energy_rate;
	iface->get_percentage = upower_device_dbus_proxy_get_percentage;
	iface->get_voltage = upower_device_dbus_proxy_get_voltage;
	iface->get_technology = upower_device_dbus_proxy_get_technology;
	iface->get_vendor = upower_device_dbus_proxy_get_vendor;
	iface->get_model = upower_device_dbus_proxy_get_model;
	iface->get_serial = upower_device_dbus_proxy_get_serial;
}

static void
upower_device_dbus_interface_method_call (GDBusConnection* connection,
                                          const gchar* sender,
                                          const gchar* object_path,
                                          const gchar* interface_name,
                                          const gchar* method_name,
                                          GVariant* parameters,
                                          GDBusMethodInvocation* invocation,
                                          gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	g_object_unref (invocation);
}

static GVariant*
_dbus_upower_device_get_Type (UPowerDevice* self)
{
	guint result;
	GVariant* _reply;
	result = upower_device_get_Type (self);
	_reply = g_variant_new_uint32 (result);
	return _reply;
}

static GVariant*
_dbus_upower_device_get_power_supply (UPowerDevice* self)
{
	gboolean result;
	GVariant* _reply;
	result = upower_device_get_power_supply (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}

static GVariant*
_dbus_upower_device_get_online (UPowerDevice* self)
{
	gboolean result;
	GVariant* _reply;
	result = upower_device_get_online (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}

static GVariant*
_dbus_upower_device_get_is_present (UPowerDevice* self)
{
	gboolean result;
	GVariant* _reply;
	result = upower_device_get_is_present (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}

static GVariant*
_dbus_upower_device_get_state (UPowerDevice* self)
{
	guint result;
	GVariant* _reply;
	result = upower_device_get_state (self);
	_reply = g_variant_new_uint32 (result);
	return _reply;
}

static GVariant*
_dbus_upower_device_get_is_rechargeable (UPowerDevice* self)
{
	gboolean result;
	GVariant* _reply;
	result = upower_device_get_is_rechargeable (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}

static GVariant*
_dbus_upower_device_get_capacity (UPowerDevice* self)
{
	gdouble result;
	GVariant* _reply;
	result = upower_device_get_capacity (self);
	_reply = g_variant_new_double (result);
	return _reply;
}

static GVariant*
_dbus_upower_device_get_time_to_empty (UPowerDevice* self)
{
	gint64 result;
	GVariant* _reply;
	result = upower_device_get_time_to_empty (self);
	_reply = g_variant_new_int64 (result);
	return _reply;
}

static GVariant*
_dbus_upower_device_get_time_to_full (UPowerDevice* self)
{
	gint64 result;
	GVariant* _reply;
	result = upower_device_get_time_to_full (self);
	_reply = g_variant_new_int64 (result);
	return _reply;
}

static GVariant*
_dbus_upower_device_get_energy (UPowerDevice* self)
{
	gdouble result;
	GVariant* _reply;
	result = upower_device_get_energy (self);
	_reply = g_variant_new_double (result);
	return _reply;
}

static GVariant*
_dbus_upower_device_get_energy_empty (UPowerDevice* self)
{
	gdouble result;
	GVariant* _reply;
	result = upower_device_get_energy_empty (self);
	_reply = g_variant_new_double (result);
	return _reply;
}

static GVariant*
_dbus_upower_device_get_energy_full (UPowerDevice* self)
{
	gdouble result;
	GVariant* _reply;
	result = upower_device_get_energy_full (self);
	_reply = g_variant_new_double (result);
	return _reply;
}

static GVariant*
_dbus_upower_device_get_energy_full_design (UPowerDevice* self)
{
	gdouble result;
	GVariant* _reply;
	result = upower_device_get_energy_full_design (self);
	_reply = g_variant_new_double (result);
	return _reply;
}

static GVariant*
_dbus_upower_device_get_energy_rate (UPowerDevice* self)
{
	gdouble result;
	GVariant* _reply;
	result = upower_device_get_energy_rate (self);
	_reply = g_variant_new_double (result);
	return _reply;
}

static GVariant*
_dbus_upower_device_get_percentage (UPowerDevice* self)
{
	gdouble result;
	GVariant* _reply;
	result = upower_device_get_percentage (self);
	_reply = g_variant_new_double (result);
	return _reply;
}

static GVariant*
_dbus_upower_device_get_voltage (UPowerDevice* self)
{
	gdouble result;
	GVariant* _reply;
	result = upower_device_get_voltage (self);
	_reply = g_variant_new_double (result);
	return _reply;
}

static GVariant*
_dbus_upower_device_get_technology (UPowerDevice* self)
{
	guint result;
	GVariant* _reply;
	result = upower_device_get_technology (self);
	_reply = g_variant_new_uint32 (result);
	return _reply;
}

static GVariant*
_dbus_upower_device_get_vendor (UPowerDevice* self)
{
	gchar* result;
	GVariant* _reply;
	result = upower_device_get_vendor (self);
	_reply = g_variant_new_string (result);
	_g_free0 (result);
	return _reply;
}

static GVariant*
_dbus_upower_device_get_model (UPowerDevice* self)
{
	gchar* result;
	GVariant* _reply;
	result = upower_device_get_model (self);
	_reply = g_variant_new_string (result);
	_g_free0 (result);
	return _reply;
}

static GVariant*
_dbus_upower_device_get_serial (UPowerDevice* self)
{
	gchar* result;
	GVariant* _reply;
	result = upower_device_get_serial (self);
	_reply = g_variant_new_string (result);
	_g_free0 (result);
	return _reply;
}

static GVariant*
upower_device_dbus_interface_get_property (GDBusConnection* connection,
                                           const gchar* sender,
                                           const gchar* object_path,
                                           const gchar* interface_name,
                                           const gchar* property_name,
                                           GError** error,
                                           gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "Type") == 0) {
		return _dbus_upower_device_get_Type (object);
	} else if (strcmp (property_name, "PowerSupply") == 0) {
		return _dbus_upower_device_get_power_supply (object);
	} else if (strcmp (property_name, "Online") == 0) {
		return _dbus_upower_device_get_online (object);
	} else if (strcmp (property_name, "IsPresent") == 0) {
		return _dbus_upower_device_get_is_present (object);
	} else if (strcmp (property_name, "State") == 0) {
		return _dbus_upower_device_get_state (object);
	} else if (strcmp (property_name, "IsRechargeable") == 0) {
		return _dbus_upower_device_get_is_rechargeable (object);
	} else if (strcmp (property_name, "Capacity") == 0) {
		return _dbus_upower_device_get_capacity (object);
	} else if (strcmp (property_name, "TimeToEmpty") == 0) {
		return _dbus_upower_device_get_time_to_empty (object);
	} else if (strcmp (property_name, "TimeToFull") == 0) {
		return _dbus_upower_device_get_time_to_full (object);
	} else if (strcmp (property_name, "Energy") == 0) {
		return _dbus_upower_device_get_energy (object);
	} else if (strcmp (property_name, "EnergyEmpty") == 0) {
		return _dbus_upower_device_get_energy_empty (object);
	} else if (strcmp (property_name, "EnergyFull") == 0) {
		return _dbus_upower_device_get_energy_full (object);
	} else if (strcmp (property_name, "EnergyFullDesign") == 0) {
		return _dbus_upower_device_get_energy_full_design (object);
	} else if (strcmp (property_name, "EnergyRate") == 0) {
		return _dbus_upower_device_get_energy_rate (object);
	} else if (strcmp (property_name, "Percentage") == 0) {
		return _dbus_upower_device_get_percentage (object);
	} else if (strcmp (property_name, "Voltage") == 0) {
		return _dbus_upower_device_get_voltage (object);
	} else if (strcmp (property_name, "Technology") == 0) {
		return _dbus_upower_device_get_technology (object);
	} else if (strcmp (property_name, "Vendor") == 0) {
		return _dbus_upower_device_get_vendor (object);
	} else if (strcmp (property_name, "Model") == 0) {
		return _dbus_upower_device_get_model (object);
	} else if (strcmp (property_name, "Serial") == 0) {
		return _dbus_upower_device_get_serial (object);
	}
	return NULL;
}

static gboolean
upower_device_dbus_interface_set_property (GDBusConnection* connection,
                                           const gchar* sender,
                                           const gchar* object_path,
                                           const gchar* interface_name,
                                           const gchar* property_name,
                                           GVariant* value,
                                           GError** error,
                                           gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

static void
_dbus_upower_device_changed (GObject* _sender,
                             gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.freedesktop.UPower.Device", "Changed", _arguments, NULL);
}

guint
upower_device_register_object (gpointer object,
                               GDBusConnection* connection,
                               const gchar* path,
                               GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_upower_device_dbus_interface_info), &_upower_device_dbus_interface_vtable, data, _upower_device_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "changed", (GCallback) _dbus_upower_device_changed, data);
	return result;
}

static void
_upower_device_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_upower_device_changed, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

static inline gpointer
menu_bar_get_instance_private (MenuBar* self)
{
	return G_STRUCT_MEMBER_P (self, MenuBar_private_offset);
}

MenuBar*
menu_bar_construct (GType object_type,
                    Background* bg,
                    GtkAccelGroup* ag,
                    MainWindow* mw)
{
	MenuBar * self = NULL;
#line 88 "menubar.vala"
	g_return_val_if_fail (bg != NULL, NULL);
#line 88 "menubar.vala"
	g_return_val_if_fail (ag != NULL, NULL);
#line 88 "menubar.vala"
	g_return_val_if_fail (mw != NULL, NULL);
#line 90 "menubar.vala"
	self = (MenuBar*) g_object_new (object_type, "background", bg, "accel-group", ag, "main-window", mw, NULL);
#line 88 "menubar.vala"
	return self;
#line 2822 "menubar.c"
}

MenuBar*
menu_bar_new (Background* bg,
              GtkAccelGroup* ag,
              MainWindow* mw)
{
#line 88 "menubar.vala"
	return menu_bar_construct (TYPE_MENU_BAR, bg, ag, mw);
#line 2832 "menubar.c"
}

static gboolean
menu_bar_real_draw (GtkWidget* base,
                    cairo_t* c)
{
	MenuBar * self;
	Background* _tmp0_;
	GList* _tmp5_;
	gboolean result = FALSE;
#line 93 "menubar.vala"
	self = (MenuBar*) base;
#line 93 "menubar.vala"
	g_return_val_if_fail (c != NULL, FALSE);
#line 95 "menubar.vala"
	_tmp0_ = self->priv->_background;
#line 95 "menubar.vala"
	if (_tmp0_ != NULL) {
#line 2851 "menubar.c"
		gint x = 0;
		gint y = 0;
		Background* _tmp1_;
		gint _tmp2_ = 0;
		gint _tmp3_ = 0;
		Background* _tmp4_;
#line 98 "menubar.vala"
		_tmp1_ = self->priv->_background;
#line 98 "menubar.vala"
		gtk_widget_translate_coordinates ((GtkWidget*) _tmp1_, (GtkWidget*) self, 0, 0, &_tmp2_, &_tmp3_);
#line 98 "menubar.vala"
		x = _tmp2_;
#line 98 "menubar.vala"
		y = _tmp3_;
#line 99 "menubar.vala"
		cairo_save (c);
#line 100 "menubar.vala"
		cairo_translate (c, (gdouble) x, (gdouble) y);
#line 101 "menubar.vala"
		_tmp4_ = self->priv->_background;
#line 101 "menubar.vala"
		background_draw_full (_tmp4_, c, BACKGROUND_DRAW_FLAGS_NONE);
#line 102 "menubar.vala"
		cairo_restore (c);
#line 2876 "menubar.c"
	}
#line 105 "menubar.vala"
	cairo_set_source_rgb (c, 0.1, 0.1, 0.1);
#line 106 "menubar.vala"
	cairo_paint_with_alpha (c, 0.4);
#line 108 "menubar.vala"
	_tmp5_ = gtk_container_get_children ((GtkContainer*) self);
#line 2884 "menubar.c"
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
#line 108 "menubar.vala"
		child_collection = _tmp5_;
#line 108 "menubar.vala"
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
#line 2892 "menubar.c"
			GtkWidget* child = NULL;
#line 108 "menubar.vala"
			child = (GtkWidget*) child_it->data;
#line 2896 "menubar.c"
			{
				GtkWidget* _tmp6_;
#line 110 "menubar.vala"
				_tmp6_ = child;
#line 110 "menubar.vala"
				gtk_container_propagate_draw ((GtkContainer*) self, _tmp6_, c);
#line 2903 "menubar.c"
			}
		}
#line 108 "menubar.vala"
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
#line 2908 "menubar.c"
	}
#line 113 "menubar.vala"
	result = FALSE;
#line 113 "menubar.vala"
	return result;
#line 2914 "menubar.c"
}

void
menu_bar_set_keyboard_state (MenuBar* self)
{
	GtkCheckMenuItem* _tmp0_;
#line 120 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 122 "menubar.vala"
	_tmp0_ = self->priv->onscreen_keyboard_item;
#line 122 "menubar.vala"
	gtk_check_menu_item_set_active (_tmp0_, ug_settings_get_boolean (UG_SETTINGS_KEY_ONSCREEN_KEYBOARD));
#line 2927 "menubar.c"
}

static void
menu_bar_on_sleeping (MenuBar* self)
{
#line 243 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 2935 "menubar.c"
}

static void
menu_bar_on_resuming (MenuBar* self)
{
#line 247 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 249 "menubar.vala"
	menu_bar_query_upower_daemon (self);
#line 2945 "menubar.c"
}

static void
menu_bar_on_changed (MenuBar* self)
{
#line 252 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 254 "menubar.vala"
	menu_bar_query_upower_daemon (self);
#line 2955 "menubar.c"
}

static void
menu_bar_on_power_device_added (MenuBar* self,
                                const char* device)
{
#line 257 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 257 "menubar.vala"
	g_return_if_fail (device != NULL);
#line 259 "menubar.vala"
	menu_bar_query_upower_device (self, device, NULL, NULL);
#line 2968 "menubar.c"
}

static void
menu_bar_on_power_device_changed (MenuBar* self,
                                  const char* device)
{
#line 262 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 262 "menubar.vala"
	g_return_if_fail (device != NULL);
#line 264 "menubar.vala"
	menu_bar_query_upower_device (self, device, NULL, NULL);
#line 2981 "menubar.c"
}

static gboolean
menu_bar_query_upower_daemon (MenuBar* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 267 "menubar.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2991 "menubar.c"
	{
		UPowerDaemon* _tmp0_;
		gboolean _tmp1_;
		gboolean _tmp2_;
#line 270 "menubar.vala"
		_tmp0_ = self->priv->upowerd;
#line 270 "menubar.vala"
		_tmp1_ = upower_daemon_get_on_battery (_tmp0_);
#line 270 "menubar.vala"
		_tmp2_ = _tmp1_;
#line 270 "menubar.vala"
		if (_tmp2_ == TRUE) {
#line 3004 "menubar.c"
			char** _tmp3_ = NULL;
			UPowerDaemon* _tmp4_;
			gint _tmp5_ = 0;
			char** _tmp6_;
			gint _tmp3__length1;
			gint __tmp3__size_;
#line 271 "menubar.vala"
			_tmp4_ = self->priv->upowerd;
#line 271 "menubar.vala"
			_tmp6_ = upower_daemon_enumerate_devices (_tmp4_, &_tmp5_, &_inner_error0_);
#line 271 "menubar.vala"
			_tmp3_ = _tmp6_;
#line 271 "menubar.vala"
			_tmp3__length1 = _tmp5_;
#line 271 "menubar.vala"
			__tmp3__size_ = _tmp3__length1;
#line 271 "menubar.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3023 "menubar.c"
				goto __catch0_g_error;
			}
			{
				char** o_collection = NULL;
				gint o_collection_length1 = 0;
				gint _o_collection_size_ = 0;
				gint o_it = 0;
#line 271 "menubar.vala"
				o_collection = _tmp3_;
#line 271 "menubar.vala"
				o_collection_length1 = _tmp3__length1;
#line 271 "menubar.vala"
				for (o_it = 0; o_it < o_collection_length1; o_it = o_it + 1) {
#line 3037 "menubar.c"
					char* _tmp7_;
					char* o = NULL;
#line 271 "menubar.vala"
					_tmp7_ = g_strdup (o_collection[o_it]);
#line 271 "menubar.vala"
					o = _tmp7_;
#line 3044 "menubar.c"
					{
						const char* _tmp8_;
#line 272 "menubar.vala"
						_tmp8_ = o;
#line 272 "menubar.vala"
						menu_bar_query_upower_device (self, _tmp8_, NULL, NULL);
#line 271 "menubar.vala"
						_g_free0 (o);
#line 3053 "menubar.c"
					}
				}
			}
#line 270 "menubar.vala"
			_tmp3_ = (_vala_array_free (_tmp3_, _tmp3__length1, (GDestroyNotify) g_free), NULL);
#line 3059 "menubar.c"
		} else {
			GtkMenuItem* _tmp9_;
#line 276 "menubar.vala"
			_tmp9_ = self->priv->power_menu_item;
#line 276 "menubar.vala"
			gtk_widget_hide ((GtkWidget*) _tmp9_);
#line 3066 "menubar.c"
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp10_;
		const gchar* _tmp11_;
#line 269 "menubar.vala"
		e = _inner_error0_;
#line 269 "menubar.vala"
		_inner_error0_ = NULL;
#line 280 "menubar.vala"
		_tmp10_ = e;
#line 280 "menubar.vala"
		_tmp11_ = _tmp10_->message;
#line 280 "menubar.vala"
		g_warning ("menubar.vala:280: Error while querying upower daemon: %s", _tmp11_);
#line 269 "menubar.vala"
		_g_error_free0 (e);
#line 3087 "menubar.c"
	}
	__finally0:
#line 269 "menubar.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3092 "menubar.c"
		gboolean _tmp12_ = FALSE;
#line 269 "menubar.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 269 "menubar.vala"
		g_clear_error (&_inner_error0_);
#line 269 "menubar.vala"
		return _tmp12_;
#line 3100 "menubar.c"
	}
#line 282 "menubar.vala"
	result = TRUE;
#line 282 "menubar.vala"
	return result;
#line 3106 "menubar.c"
}

static void
menu_bar_query_upower_device_data_free (gpointer _data)
{
	MenuBarQueryUpowerDeviceData* _data_;
	_data_ = _data;
#line 78 "menubar.vala"
	_g_free0 (_data_->dev_path);
#line 78 "menubar.vala"
	_g_object_unref0 (_data_->self);
#line 78 "menubar.vala"
	g_slice_free (MenuBarQueryUpowerDeviceData, _data_);
#line 3120 "menubar.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 78 "menubar.vala"
	return self ? g_object_ref (self) : NULL;
#line 3128 "menubar.c"
}

static void
menu_bar_query_upower_device (MenuBar* self,
                              const char* dev_path,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_)
{
	MenuBarQueryUpowerDeviceData* _data_;
	MenuBar* _tmp0_;
	char* _tmp1_;
#line 78 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 78 "menubar.vala"
	g_return_if_fail (dev_path != NULL);
#line 78 "menubar.vala"
	_data_ = g_slice_new0 (MenuBarQueryUpowerDeviceData);
#line 78 "menubar.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 78 "menubar.vala"
	g_task_set_task_data (_data_->_async_result, _data_, menu_bar_query_upower_device_data_free);
#line 78 "menubar.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 78 "menubar.vala"
	_data_->self = _tmp0_;
#line 78 "menubar.vala"
	_tmp1_ = g_strdup (dev_path);
#line 78 "menubar.vala"
	_g_free0 (_data_->dev_path);
#line 78 "menubar.vala"
	_data_->dev_path = _tmp1_;
#line 78 "menubar.vala"
	menu_bar_query_upower_device_co (_data_);
#line 3162 "menubar.c"
}

static void
menu_bar_query_upower_device_finish (MenuBar* self,
                                     GAsyncResult* _res_)
{
	MenuBarQueryUpowerDeviceData* _data_;
#line 78 "menubar.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 3172 "menubar.c"
}

static gboolean
menu_bar_query_upower_device_co (MenuBarQueryUpowerDeviceData* _data_)
{
#line 285 "menubar.vala"
	switch (_data_->_state_) {
#line 285 "menubar.vala"
		case 0:
#line 3182 "menubar.c"
		goto _state_0;
		default:
#line 285 "menubar.vala"
		g_assert_not_reached ();
#line 3187 "menubar.c"
	}
	_state_0:
	{
#line 291 "menubar.vala"
		_data_->_tmp1_ = (UPowerDevice*) g_initable_new (UPOWER_TYPE_DEVICE_PROXY, NULL, &_data_->_inner_error0_, "g-flags", 0, "g-name", "org.freedesktop.UPower", "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", (const gchar*) _data_->dev_path, "g-interface-name", "org.freedesktop.UPower.Device", NULL);
#line 291 "menubar.vala"
		_data_->_tmp0_ = (UPowerDevice*) _data_->_tmp1_;
#line 291 "menubar.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 291 "menubar.vala"
			if (_data_->_inner_error0_->domain == G_IO_ERROR) {
#line 3199 "menubar.c"
				goto __catch0_g_io_error;
			}
#line 291 "menubar.vala"
			_g_object_unref0 (_data_->dev);
#line 291 "menubar.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 291 "menubar.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 291 "menubar.vala"
			g_object_unref (_data_->_async_result);
#line 291 "menubar.vala"
			return FALSE;
#line 3212 "menubar.c"
		}
#line 291 "menubar.vala"
		_data_->_tmp2_ = _data_->_tmp0_;
#line 291 "menubar.vala"
		_data_->_tmp0_ = NULL;
#line 291 "menubar.vala"
		_g_object_unref0 (_data_->dev);
#line 291 "menubar.vala"
		_data_->dev = _data_->_tmp2_;
#line 290 "menubar.vala"
		_g_object_unref0 (_data_->_tmp0_);
#line 3224 "menubar.c"
	}
	goto __finally0;
	__catch0_g_io_error:
	{
#line 290 "menubar.vala"
		_data_->io = _data_->_inner_error0_;
#line 290 "menubar.vala"
		_data_->_inner_error0_ = NULL;
#line 293 "menubar.vala"
		_data_->_tmp3_ = _data_->io;
#line 293 "menubar.vala"
		_data_->_tmp4_ = _data_->_tmp3_->message;
#line 293 "menubar.vala"
		g_warning ("menubar.vala:293: Could not connect to UPower/Device: %s", _data_->_tmp4_);
#line 294 "menubar.vala"
		_g_error_free0 (_data_->io);
#line 294 "menubar.vala"
		_g_object_unref0 (_data_->dev);
#line 294 "menubar.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 294 "menubar.vala"
		if (_data_->_state_ != 0) {
#line 294 "menubar.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 294 "menubar.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3251 "menubar.c"
			}
		}
#line 294 "menubar.vala"
		g_object_unref (_data_->_async_result);
#line 294 "menubar.vala"
		return FALSE;
#line 3258 "menubar.c"
	}
	__finally0:
#line 290 "menubar.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 290 "menubar.vala"
		_g_object_unref0 (_data_->dev);
#line 290 "menubar.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 290 "menubar.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 290 "menubar.vala"
		g_object_unref (_data_->_async_result);
#line 290 "menubar.vala"
		return FALSE;
#line 3273 "menubar.c"
	}
#line 298 "menubar.vala"
	_data_->_tmp5_ = _data_->dev;
#line 298 "menubar.vala"
	_data_->_tmp6_ = upower_device_get_Type (_data_->_tmp5_);
#line 298 "menubar.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 298 "menubar.vala"
	_data_->type = _data_->_tmp7_;
#line 299 "menubar.vala"
	if (_data_->type == ((guint) 1)) {
#line 3285 "menubar.c"
	} else {
#line 300 "menubar.vala"
		if (_data_->type == ((guint) 2)) {
#line 300 "menubar.vala"
			_data_->_tmp9_ = _data_->dev;
#line 300 "menubar.vala"
			_data_->_tmp10_ = upower_device_get_is_present (_data_->_tmp9_);
#line 300 "menubar.vala"
			_data_->_tmp11_ = _data_->_tmp10_;
#line 300 "menubar.vala"
			_data_->_tmp8_ = _data_->_tmp11_ == TRUE;
#line 3297 "menubar.c"
		} else {
#line 300 "menubar.vala"
			_data_->_tmp8_ = FALSE;
#line 3301 "menubar.c"
		}
#line 300 "menubar.vala"
		if (_data_->_tmp8_) {
#line 301 "menubar.vala"
			_data_->_tmp12_ = _data_->dev;
#line 301 "menubar.vala"
			menu_bar_update_power (_data_->self, _data_->_tmp12_);
#line 3309 "menubar.c"
		} else {
#line 302 "menubar.vala"
			if (_data_->type == ((guint) 3)) {
#line 3313 "menubar.c"
			} else {
#line 303 "menubar.vala"
				if (_data_->type == ((guint) 5)) {
#line 3317 "menubar.c"
				} else {
#line 304 "menubar.vala"
					if (_data_->type == ((guint) 6)) {
#line 3321 "menubar.c"
					} else {
#line 305 "menubar.vala"
						if (_data_->type == ((guint) 7)) {
#line 3325 "menubar.c"
						} else {
#line 306 "menubar.vala"
							if (_data_->type == ((guint) 8)) {
#line 3329 "menubar.c"
							}
						}
					}
				}
			}
		}
	}
#line 285 "menubar.vala"
	_g_object_unref0 (_data_->dev);
#line 285 "menubar.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 285 "menubar.vala"
	if (_data_->_state_ != 0) {
#line 285 "menubar.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 285 "menubar.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3347 "menubar.c"
		}
	}
#line 285 "menubar.vala"
	g_object_unref (_data_->_async_result);
#line 285 "menubar.vala"
	return FALSE;
#line 3354 "menubar.c"
}

static void
menu_bar_on_power_device_removed (MenuBar* self,
                                  const char* device)
{
#line 310 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 310 "menubar.vala"
	g_return_if_fail (device != NULL);
#line 312 "menubar.vala"
	menu_bar_query_upower_daemon (self);
#line 3367 "menubar.c"
}

static void
menu_bar_update_power (MenuBar* self,
                       UPowerDevice* device)
{
#line 315 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 317 "menubar.vala"
	if (device == NULL) {
#line 3378 "menubar.c"
		GtkMenuItem* _tmp0_;
#line 318 "menubar.vala"
		_tmp0_ = self->priv->power_menu_item;
#line 318 "menubar.vala"
		gtk_widget_hide ((GtkWidget*) _tmp0_);
#line 3384 "menubar.c"
	} else {
		gchar* buffer = NULL;
		gchar* _tmp1_;
		gint buffer_length1;
		gint _buffer_size_;
		const gchar* str = NULL;
		gdouble _tmp2_;
		gdouble _tmp3_;
		gchar* _tmp4_;
		gint _tmp4__length1;
		const gchar* _tmp5_;
		gchar* percentage_string = NULL;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		GtkLabel* _tmp8_;
		const gchar* _tmp9_;
		GtkMenuItem* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* icon = NULL;
		gchar* _tmp16_;
		gdouble _tmp17_;
		gdouble _tmp18_;
		gdouble _tmp20_;
		gdouble _tmp21_;
		gdouble _tmp23_;
		gdouble _tmp24_;
		GtkImage* _tmp26_;
		const gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		GtkMenuItem* _tmp30_;
#line 321 "menubar.vala"
		_tmp1_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
#line 321 "menubar.vala"
		buffer = _tmp1_;
#line 321 "menubar.vala"
		buffer_length1 = G_ASCII_DTOSTR_BUF_SIZE;
#line 321 "menubar.vala"
		_buffer_size_ = buffer_length1;
#line 322 "menubar.vala"
		_tmp2_ = upower_device_get_percentage (device);
#line 322 "menubar.vala"
		_tmp3_ = _tmp2_;
#line 322 "menubar.vala"
		_tmp4_ = buffer;
#line 322 "menubar.vala"
		_tmp4__length1 = buffer_length1;
#line 322 "menubar.vala"
		_tmp5_ = g_ascii_dtostr (_tmp4_, (gint) _tmp4__length1, _tmp3_);
#line 322 "menubar.vala"
		str = _tmp5_;
#line 323 "menubar.vala"
		_tmp6_ = str;
#line 323 "menubar.vala"
		_tmp7_ = g_strconcat (_tmp6_, "%", NULL);
#line 323 "menubar.vala"
		percentage_string = _tmp7_;
#line 324 "menubar.vala"
		_tmp8_ = self->priv->power_label;
#line 324 "menubar.vala"
		_tmp9_ = percentage_string;
#line 324 "menubar.vala"
		gtk_label_set_label (_tmp8_, _tmp9_);
#line 325 "menubar.vala"
		_tmp10_ = self->priv->power_menu_item;
#line 325 "menubar.vala"
		_tmp11_ = g_strconcat (_ ("Power:"), " ", NULL);
#line 325 "menubar.vala"
		_tmp12_ = _tmp11_;
#line 325 "menubar.vala"
		_tmp13_ = percentage_string;
#line 325 "menubar.vala"
		_tmp14_ = g_strconcat (_tmp12_, _tmp13_, NULL);
#line 325 "menubar.vala"
		_tmp15_ = _tmp14_;
#line 325 "menubar.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp10_, _tmp15_);
#line 325 "menubar.vala"
		_g_free0 (_tmp15_);
#line 325 "menubar.vala"
		_g_free0 (_tmp12_);
#line 326 "menubar.vala"
		_tmp16_ = g_strdup ("battery.svg");
#line 326 "menubar.vala"
		icon = _tmp16_;
#line 327 "menubar.vala"
		_tmp17_ = upower_device_get_percentage (device);
#line 327 "menubar.vala"
		_tmp18_ = _tmp17_;
#line 327 "menubar.vala"
		if (_tmp18_ <= 50.0) {
#line 3480 "menubar.c"
			gchar* _tmp19_;
#line 328 "menubar.vala"
			_tmp19_ = g_strdup ("battery_50.svg");
#line 328 "menubar.vala"
			_g_free0 (icon);
#line 328 "menubar.vala"
			icon = _tmp19_;
#line 3488 "menubar.c"
		}
#line 330 "menubar.vala"
		_tmp20_ = upower_device_get_percentage (device);
#line 330 "menubar.vala"
		_tmp21_ = _tmp20_;
#line 330 "menubar.vala"
		if (_tmp21_ <= 25.0) {
#line 3496 "menubar.c"
			gchar* _tmp22_;
#line 331 "menubar.vala"
			_tmp22_ = g_strdup ("battery_25.svg");
#line 331 "menubar.vala"
			_g_free0 (icon);
#line 331 "menubar.vala"
			icon = _tmp22_;
#line 3504 "menubar.c"
		}
#line 333 "menubar.vala"
		_tmp23_ = upower_device_get_percentage (device);
#line 333 "menubar.vala"
		_tmp24_ = _tmp23_;
#line 333 "menubar.vala"
		if (_tmp24_ <= 10.0) {
#line 3512 "menubar.c"
			gchar* _tmp25_;
#line 334 "menubar.vala"
			_tmp25_ = g_strdup ("battery_10.svg");
#line 334 "menubar.vala"
			_g_free0 (icon);
#line 334 "menubar.vala"
			icon = _tmp25_;
#line 3520 "menubar.c"
		}
#line 336 "menubar.vala"
		_tmp26_ = self->priv->power_icon;
#line 336 "menubar.vala"
		_tmp27_ = icon;
#line 336 "menubar.vala"
		_tmp28_ = g_build_filename (PKGDATADIR, _tmp27_, NULL);
#line 336 "menubar.vala"
		_tmp29_ = _tmp28_;
#line 336 "menubar.vala"
		gtk_image_set_from_file (_tmp26_, _tmp29_);
#line 336 "menubar.vala"
		_g_free0 (_tmp29_);
#line 337 "menubar.vala"
		_tmp30_ = self->priv->power_menu_item;
#line 337 "menubar.vala"
		gtk_widget_show ((GtkWidget*) _tmp30_);
#line 317 "menubar.vala"
		_g_free0 (icon);
#line 317 "menubar.vala"
		_g_free0 (percentage_string);
#line 317 "menubar.vala"
		buffer = (g_free (buffer), NULL);
#line 3544 "menubar.c"
	}
}

static gboolean
menu_bar_update_clock (MenuBar* self)
{
	GDateTime* current_time = NULL;
	GDateTime* _tmp0_;
	GtkLabel* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GtkLabel* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gboolean result = FALSE;
#line 341 "menubar.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 343 "menubar.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 343 "menubar.vala"
	current_time = _tmp0_;
#line 344 "menubar.vala"
	_tmp1_ = self->priv->clock_label;
#line 344 "menubar.vala"
	_tmp2_ = self->priv->clock_format;
#line 344 "menubar.vala"
	_tmp3_ = g_date_time_format (current_time, _tmp2_);
#line 344 "menubar.vala"
	_tmp4_ = _tmp3_;
#line 344 "menubar.vala"
	gtk_label_set_label (_tmp1_, _tmp4_);
#line 344 "menubar.vala"
	_g_free0 (_tmp4_);
#line 345 "menubar.vala"
	_tmp5_ = self->priv->clock_label;
#line 345 "menubar.vala"
	_tmp6_ = g_date_time_format (current_time, "%x");
#line 345 "menubar.vala"
	_tmp7_ = _tmp6_;
#line 345 "menubar.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp5_, _tmp7_);
#line 345 "menubar.vala"
	_g_free0 (_tmp7_);
#line 346 "menubar.vala"
	result = TRUE;
#line 346 "menubar.vala"
	_g_date_time_unref0 (current_time);
#line 346 "menubar.vala"
	return result;
#line 3595 "menubar.c"
}

static void
menu_bar_close_pid (MenuBar* self,
                    GPid* pid)
{
#line 349 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 351 "menubar.vala"
	if ((*pid) > ((GPid) 0)) {
#line 3606 "menubar.c"
		gint status = 0;
		gint _tmp0_ = 0;
#line 353 "menubar.vala"
		kill ((pid_t) (*pid), (gint) SIGTERM);
#line 355 "menubar.vala"
		waitpid ((pid_t) (*pid), &_tmp0_, 0);
#line 355 "menubar.vala"
		status = _tmp0_;
#line 356 "menubar.vala"
		*pid = (GPid) 0;
#line 3617 "menubar.c"
	}
}

void
menu_bar_cleanup (MenuBar* self)
{
#line 360 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 362 "menubar.vala"
	menu_bar_close_pid (self, &self->priv->keyboard_pid);
#line 363 "menubar.vala"
	menu_bar_close_pid (self, &self->priv->reader_pid);
#line 3630 "menubar.c"
}

static void
menu_bar_real_get_preferred_height (GtkWidget* base,
                                    gint* min,
                                    gint* nat)
{
	MenuBar * self;
	gint _vala_min = 0;
	gint _vala_nat = 0;
#line 366 "menubar.vala"
	self = (MenuBar*) base;
#line 368 "menubar.vala"
	_vala_min = MENU_BAR_HEIGHT;
#line 369 "menubar.vala"
	_vala_nat = MENU_BAR_HEIGHT;
#line 366 "menubar.vala"
	if (min) {
#line 366 "menubar.vala"
		*min = _vala_min;
#line 3651 "menubar.c"
	}
#line 366 "menubar.vala"
	if (nat) {
#line 366 "menubar.vala"
		*nat = _vala_nat;
#line 3657 "menubar.c"
	}
}

static void
_menu_bar_keyboard_toggled_cb_gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                                           gpointer self)
{
#line 385 "menubar.vala"
	menu_bar_keyboard_toggled_cb ((MenuBar*) self, _sender);
#line 3667 "menubar.c"
}

static void
_menu_bar_high_contrast_toggled_cb_gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                                                gpointer self)
{
#line 390 "menubar.vala"
	menu_bar_high_contrast_toggled_cb ((MenuBar*) self, _sender);
#line 3676 "menubar.c"
}

static void
_menu_bar_screen_reader_toggled_cb_gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                                                gpointer self)
{
#line 396 "menubar.vala"
	menu_bar_screen_reader_toggled_cb ((MenuBar*) self, _sender);
#line 3685 "menubar.c"
}

static GtkMenuItem*
menu_bar_make_a11y_item (MenuBar* self)
{
	GtkMenuItem* a11y_item = NULL;
	GtkMenuItem* _tmp0_;
	GtkBox* hbox = NULL;
	GtkBox* _tmp1_;
	GtkImage* image = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GtkImage* _tmp4_;
	GtkImage* _tmp5_;
	GtkMenu* _tmp6_;
	GtkMenu* _tmp7_;
	GtkCheckMenuItem* _tmp8_;
	GtkCheckMenuItem* _tmp9_;
	GtkCheckMenuItem* _tmp10_;
	GtkMenu* submenu = NULL;
	GtkMenu* _tmp11_;
	GtkMenu* _tmp12_;
	GtkCheckMenuItem* _tmp13_;
	GtkCheckMenuItem* _tmp14_;
	GtkCheckMenuItem* _tmp15_;
	GtkCheckMenuItem* _tmp16_;
	GtkAccelGroup* _tmp17_;
	GtkCheckMenuItem* _tmp18_;
	GtkCheckMenuItem* _tmp19_;
	GtkCheckMenuItem* _tmp20_;
	GtkCheckMenuItem* item = NULL;
	GtkCheckMenuItem* _tmp21_;
	GtkAccelGroup* _tmp22_;
	GtkMenuItem* result = NULL;
#line 372 "menubar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 374 "menubar.vala"
	_tmp0_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 374 "menubar.vala"
	g_object_ref_sink (_tmp0_);
#line 374 "menubar.vala"
	a11y_item = _tmp0_;
#line 375 "menubar.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) a11y_item, _ ("Accessibility"));
#line 376 "menubar.vala"
	_tmp1_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 3);
#line 376 "menubar.vala"
	g_object_ref_sink (_tmp1_);
#line 376 "menubar.vala"
	hbox = _tmp1_;
#line 377 "menubar.vala"
	gtk_widget_show ((GtkWidget*) hbox);
#line 378 "menubar.vala"
	gtk_container_add ((GtkContainer*) a11y_item, (GtkWidget*) hbox);
#line 379 "menubar.vala"
	_tmp2_ = g_build_filename (PKGDATADIR, "a11y.svg", NULL);
#line 379 "menubar.vala"
	_tmp3_ = _tmp2_;
#line 379 "menubar.vala"
	_tmp4_ = (GtkImage*) gtk_image_new_from_file (_tmp3_);
#line 379 "menubar.vala"
	g_object_ref_sink (_tmp4_);
#line 379 "menubar.vala"
	_tmp5_ = _tmp4_;
#line 379 "menubar.vala"
	_g_free0 (_tmp3_);
#line 379 "menubar.vala"
	image = _tmp5_;
#line 380 "menubar.vala"
	gtk_widget_show ((GtkWidget*) image);
#line 381 "menubar.vala"
	gtk_container_add ((GtkContainer*) hbox, (GtkWidget*) image);
#line 382 "menubar.vala"
	gtk_widget_show ((GtkWidget*) a11y_item);
#line 383 "menubar.vala"
	_tmp6_ = (GtkMenu*) gtk_menu_new ();
#line 383 "menubar.vala"
	g_object_ref_sink (_tmp6_);
#line 383 "menubar.vala"
	_tmp7_ = _tmp6_;
#line 383 "menubar.vala"
	gtk_menu_item_set_submenu (a11y_item, _tmp7_);
#line 383 "menubar.vala"
	_g_object_unref0 (_tmp7_);
#line 384 "menubar.vala"
	_tmp8_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_label (_ ("Onscreen keyboard"));
#line 384 "menubar.vala"
	g_object_ref_sink (_tmp8_);
#line 384 "menubar.vala"
	_g_object_unref0 (self->priv->onscreen_keyboard_item);
#line 384 "menubar.vala"
	self->priv->onscreen_keyboard_item = _tmp8_;
#line 385 "menubar.vala"
	_tmp9_ = self->priv->onscreen_keyboard_item;
#line 385 "menubar.vala"
	g_signal_connect_object (_tmp9_, "toggled", (GCallback) _menu_bar_keyboard_toggled_cb_gtk_check_menu_item_toggled, self, 0);
#line 386 "menubar.vala"
	_tmp10_ = self->priv->onscreen_keyboard_item;
#line 386 "menubar.vala"
	gtk_widget_show ((GtkWidget*) _tmp10_);
#line 387 "menubar.vala"
	_tmp11_ = gtk_menu_item_get_submenu (a11y_item);
#line 387 "menubar.vala"
	_tmp12_ = _tmp11_;
#line 387 "menubar.vala"
	submenu = _tmp12_;
#line 388 "menubar.vala"
	_tmp13_ = self->priv->onscreen_keyboard_item;
#line 388 "menubar.vala"
	gtk_menu_shell_append ((GtkMenuShell*) submenu, (GtkMenuItem*) _tmp13_);
#line 389 "menubar.vala"
	_tmp14_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_label (_ ("High Contrast"));
#line 389 "menubar.vala"
	g_object_ref_sink (_tmp14_);
#line 389 "menubar.vala"
	_g_object_unref0 (self->priv->high_contrast_item);
#line 389 "menubar.vala"
	self->priv->high_contrast_item = _tmp14_;
#line 390 "menubar.vala"
	_tmp15_ = self->priv->high_contrast_item;
#line 390 "menubar.vala"
	g_signal_connect_object (_tmp15_, "toggled", (GCallback) _menu_bar_high_contrast_toggled_cb_gtk_check_menu_item_toggled, self, 0);
#line 391 "menubar.vala"
	_tmp16_ = self->priv->high_contrast_item;
#line 391 "menubar.vala"
	_tmp17_ = self->priv->_accel_group;
#line 391 "menubar.vala"
	gtk_widget_add_accelerator ((GtkWidget*) _tmp16_, "activate", _tmp17_, GDK_KEY_h, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);
#line 392 "menubar.vala"
	_tmp18_ = self->priv->high_contrast_item;
#line 392 "menubar.vala"
	gtk_widget_show ((GtkWidget*) _tmp18_);
#line 393 "menubar.vala"
	_tmp19_ = self->priv->high_contrast_item;
#line 393 "menubar.vala"
	gtk_menu_shell_append ((GtkMenuShell*) submenu, (GtkMenuItem*) _tmp19_);
#line 394 "menubar.vala"
	_tmp20_ = self->priv->high_contrast_item;
#line 394 "menubar.vala"
	gtk_check_menu_item_set_active (_tmp20_, ug_settings_get_boolean (UG_SETTINGS_KEY_HIGH_CONTRAST));
#line 395 "menubar.vala"
	_tmp21_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_label (_ ("Screen Reader"));
#line 395 "menubar.vala"
	g_object_ref_sink (_tmp21_);
#line 395 "menubar.vala"
	item = _tmp21_;
#line 396 "menubar.vala"
	g_signal_connect_object (item, "toggled", (GCallback) _menu_bar_screen_reader_toggled_cb_gtk_check_menu_item_toggled, self, 0);
#line 397 "menubar.vala"
	_tmp22_ = self->priv->_accel_group;
#line 397 "menubar.vala"
	gtk_widget_add_accelerator ((GtkWidget*) item, "activate", _tmp22_, GDK_KEY_s, GDK_SUPER_MASK | GDK_MOD1_MASK, GTK_ACCEL_VISIBLE);
#line 398 "menubar.vala"
	gtk_widget_show ((GtkWidget*) item);
#line 399 "menubar.vala"
	gtk_menu_shell_append ((GtkMenuShell*) submenu, (GtkMenuItem*) item);
#line 400 "menubar.vala"
	gtk_check_menu_item_set_active (item, ug_settings_get_boolean (UG_SETTINGS_KEY_SCREEN_READER));
#line 401 "menubar.vala"
	result = a11y_item;
#line 401 "menubar.vala"
	_g_object_unref0 (item);
#line 401 "menubar.vala"
	_g_object_unref0 (image);
#line 401 "menubar.vala"
	_g_object_unref0 (hbox);
#line 401 "menubar.vala"
	return result;
#line 3854 "menubar.c"
}

static void
___lambda6_ (MenuBar* self)
{
	GError* _inner_error0_ = NULL;
	{
#line 427 "menubar.vala"
		lightdm_suspend (&_inner_error0_);
#line 427 "menubar.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3866 "menubar.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
#line 425 "menubar.vala"
		e = _inner_error0_;
#line 425 "menubar.vala"
		_inner_error0_ = NULL;
#line 431 "menubar.vala"
		_tmp0_ = e;
#line 431 "menubar.vala"
		_tmp1_ = _tmp0_->message;
#line 431 "menubar.vala"
		g_warning ("menubar.vala:431: Failed to suspend: %s", _tmp1_);
#line 425 "menubar.vala"
		_g_error_free0 (e);
#line 3888 "menubar.c"
	}
	__finally0:
#line 425 "menubar.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 425 "menubar.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 425 "menubar.vala"
		g_clear_error (&_inner_error0_);
#line 425 "menubar.vala"
		return;
#line 3899 "menubar.c"
	}
}

static void
____lambda6__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
#line 423 "menubar.vala"
	___lambda6_ ((MenuBar*) self);
#line 3909 "menubar.c"
}

static void
___lambda7_ (MenuBar* self)
{
	GError* _inner_error0_ = NULL;
	{
#line 445 "menubar.vala"
		lightdm_hibernate (&_inner_error0_);
#line 445 "menubar.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3921 "menubar.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
#line 443 "menubar.vala"
		e = _inner_error0_;
#line 443 "menubar.vala"
		_inner_error0_ = NULL;
#line 449 "menubar.vala"
		_tmp0_ = e;
#line 449 "menubar.vala"
		_tmp1_ = _tmp0_->message;
#line 449 "menubar.vala"
		g_warning ("menubar.vala:449: Failed to hibernate: %s", _tmp1_);
#line 443 "menubar.vala"
		_g_error_free0 (e);
#line 3943 "menubar.c"
	}
	__finally0:
#line 443 "menubar.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 443 "menubar.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 443 "menubar.vala"
		g_clear_error (&_inner_error0_);
#line 443 "menubar.vala"
		return;
#line 3954 "menubar.c"
	}
}

static void
____lambda7__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
#line 441 "menubar.vala"
	___lambda7_ ((MenuBar*) self);
#line 3964 "menubar.c"
}

static void
_menu_bar_shutdown_cb_gtk_menu_item_activate (GtkMenuItem* _sender,
                                              gpointer self)
{
#line 455 "menubar.vala"
	menu_bar_shutdown_cb ((MenuBar*) self, _sender);
#line 3973 "menubar.c"
}

static GtkMenuItem*
menu_bar_make_session_item (MenuBar* self)
{
	GtkMenuItem* item = NULL;
	GtkMenuItem* _tmp0_;
	GtkMenuItem* _tmp1_;
	GtkBox* hbox = NULL;
	GtkBox* _tmp2_;
	GtkBox* _tmp3_;
	GtkMenuItem* _tmp4_;
	GtkBox* _tmp5_;
	GtkImage* image = NULL;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GtkImage* _tmp8_;
	GtkImage* _tmp9_;
	GtkImage* _tmp10_;
	GtkBox* _tmp11_;
	GtkImage* _tmp12_;
	GtkMenuItem* _tmp13_;
	GtkMenuItem* _tmp14_;
	GtkMenu* _tmp15_;
	GtkMenu* _tmp16_;
	GtkMenu* submenu = NULL;
	GtkMenuItem* _tmp17_;
	GtkMenu* _tmp18_;
	GtkMenu* _tmp19_;
	GtkMenuItem* menu_item = NULL;
	GtkMenuItem* _tmp30_;
	GtkMenu* _tmp31_;
	GtkMenuItem* result = NULL;
#line 404 "menubar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 406 "menubar.vala"
	_tmp0_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 406 "menubar.vala"
	g_object_ref_sink (_tmp0_);
#line 406 "menubar.vala"
	item = _tmp0_;
#line 407 "menubar.vala"
	_tmp1_ = item;
#line 407 "menubar.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp1_, _ ("Quit..."));
#line 408 "menubar.vala"
	_tmp2_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 3);
#line 408 "menubar.vala"
	g_object_ref_sink (_tmp2_);
#line 408 "menubar.vala"
	hbox = _tmp2_;
#line 409 "menubar.vala"
	_tmp3_ = hbox;
#line 409 "menubar.vala"
	gtk_widget_show ((GtkWidget*) _tmp3_);
#line 410 "menubar.vala"
	_tmp4_ = item;
#line 410 "menubar.vala"
	_tmp5_ = hbox;
#line 410 "menubar.vala"
	gtk_container_add ((GtkContainer*) _tmp4_, (GtkWidget*) _tmp5_);
#line 411 "menubar.vala"
	_tmp6_ = g_build_filename (PKGDATADIR, "shutdown.svg", NULL);
#line 411 "menubar.vala"
	_tmp7_ = _tmp6_;
#line 411 "menubar.vala"
	_tmp8_ = (GtkImage*) gtk_image_new_from_file (_tmp7_);
#line 411 "menubar.vala"
	g_object_ref_sink (_tmp8_);
#line 411 "menubar.vala"
	_tmp9_ = _tmp8_;
#line 411 "menubar.vala"
	_g_free0 (_tmp7_);
#line 411 "menubar.vala"
	image = _tmp9_;
#line 412 "menubar.vala"
	_tmp10_ = image;
#line 412 "menubar.vala"
	gtk_widget_show ((GtkWidget*) _tmp10_);
#line 413 "menubar.vala"
	_tmp11_ = hbox;
#line 413 "menubar.vala"
	_tmp12_ = image;
#line 413 "menubar.vala"
	gtk_container_add ((GtkContainer*) _tmp11_, (GtkWidget*) _tmp12_);
#line 414 "menubar.vala"
	_tmp13_ = item;
#line 414 "menubar.vala"
	gtk_widget_show ((GtkWidget*) _tmp13_);
#line 415 "menubar.vala"
	_tmp14_ = item;
#line 415 "menubar.vala"
	_tmp15_ = (GtkMenu*) gtk_menu_new ();
#line 415 "menubar.vala"
	g_object_ref_sink (_tmp15_);
#line 415 "menubar.vala"
	_tmp16_ = _tmp15_;
#line 415 "menubar.vala"
	gtk_menu_item_set_submenu (_tmp14_, _tmp16_);
#line 415 "menubar.vala"
	_g_object_unref0 (_tmp16_);
#line 416 "menubar.vala"
	_tmp17_ = item;
#line 416 "menubar.vala"
	_tmp18_ = gtk_menu_item_get_submenu (_tmp17_);
#line 416 "menubar.vala"
	_tmp19_ = _tmp18_;
#line 416 "menubar.vala"
	submenu = _tmp19_;
#line 418 "menubar.vala"
	if (lightdm_get_can_suspend ()) {
#line 4085 "menubar.c"
		GtkMenuItem* menu_item = NULL;
		GtkMenuItem* _tmp20_;
		GtkMenuItem* _tmp21_;
		GtkMenu* _tmp22_;
		GtkMenuItem* _tmp23_;
		GtkMenuItem* _tmp24_;
#line 420 "menubar.vala"
		_tmp20_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Suspend"));
#line 420 "menubar.vala"
		g_object_ref_sink (_tmp20_);
#line 420 "menubar.vala"
		menu_item = _tmp20_;
#line 421 "menubar.vala"
		_tmp21_ = menu_item;
#line 421 "menubar.vala"
		gtk_widget_show ((GtkWidget*) _tmp21_);
#line 422 "menubar.vala"
		_tmp22_ = submenu;
#line 422 "menubar.vala"
		_tmp23_ = menu_item;
#line 422 "menubar.vala"
		gtk_menu_shell_append ((GtkMenuShell*) _tmp22_, _tmp23_);
#line 423 "menubar.vala"
		_tmp24_ = menu_item;
#line 423 "menubar.vala"
		g_signal_connect_object (_tmp24_, "activate", (GCallback) ____lambda6__gtk_menu_item_activate, self, 0);
#line 418 "menubar.vala"
		_g_object_unref0 (menu_item);
#line 4114 "menubar.c"
	}
#line 436 "menubar.vala"
	if (lightdm_get_can_hibernate ()) {
#line 4118 "menubar.c"
		GtkMenuItem* menu_item = NULL;
		GtkMenuItem* _tmp25_;
		GtkMenuItem* _tmp26_;
		GtkMenu* _tmp27_;
		GtkMenuItem* _tmp28_;
		GtkMenuItem* _tmp29_;
#line 438 "menubar.vala"
		_tmp25_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Hibernate"));
#line 438 "menubar.vala"
		g_object_ref_sink (_tmp25_);
#line 438 "menubar.vala"
		menu_item = _tmp25_;
#line 439 "menubar.vala"
		_tmp26_ = menu_item;
#line 439 "menubar.vala"
		gtk_widget_show ((GtkWidget*) _tmp26_);
#line 440 "menubar.vala"
		_tmp27_ = submenu;
#line 440 "menubar.vala"
		_tmp28_ = menu_item;
#line 440 "menubar.vala"
		gtk_menu_shell_append ((GtkMenuShell*) _tmp27_, _tmp28_);
#line 441 "menubar.vala"
		_tmp29_ = menu_item;
#line 441 "menubar.vala"
		g_signal_connect_object (_tmp29_, "activate", (GCallback) ____lambda7__gtk_menu_item_activate, self, 0);
#line 436 "menubar.vala"
		_g_object_unref0 (menu_item);
#line 4147 "menubar.c"
	}
#line 454 "menubar.vala"
	_tmp30_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Quit..."));
#line 454 "menubar.vala"
	g_object_ref_sink (_tmp30_);
#line 454 "menubar.vala"
	menu_item = _tmp30_;
#line 455 "menubar.vala"
	g_signal_connect_object (menu_item, "activate", (GCallback) _menu_bar_shutdown_cb_gtk_menu_item_activate, self, 0);
#line 456 "menubar.vala"
	gtk_widget_show ((GtkWidget*) menu_item);
#line 457 "menubar.vala"
	_tmp31_ = submenu;
#line 457 "menubar.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp31_, menu_item);
#line 459 "menubar.vala"
	result = item;
#line 459 "menubar.vala"
	_g_object_unref0 (menu_item);
#line 459 "menubar.vala"
	_g_object_unref0 (image);
#line 459 "menubar.vala"
	_g_object_unref0 (hbox);
#line 459 "menubar.vala"
	return result;
#line 4173 "menubar.c"
}

static GtkMenuItem*
menu_bar_make_keyboard_item (MenuBar* self)
{
	GtkMenuItem* item = NULL;
	GtkMenuItem* _tmp0_;
	GtkBox* hbox = NULL;
	GtkBox* _tmp1_;
	GtkBox* _tmp2_;
	GtkMenuItem* _tmp3_;
	GtkBox* _tmp4_;
	GtkImage* image = NULL;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GtkImage* _tmp7_;
	GtkImage* _tmp8_;
	GtkImage* _tmp9_;
	GtkBox* _tmp10_;
	GtkImage* _tmp11_;
	GtkBox* _tmp12_;
	GtkLabel* label = NULL;
	GtkLabel* _tmp13_;
	GtkLabel* _tmp14_;
	LightDMLayout* current_layout = NULL;
	LightDMLayout* _tmp15_;
	LightDMLayout* _tmp16_;
	LightDMLayout* _tmp17_;
	GdkRGBA keyboard_fg = {0};
	GtkLabel* _tmp30_;
	GtkStyleContext* _tmp31_;
	GdkRGBA _tmp32_ = {0};
	GtkLabel* _tmp33_;
	GdkRGBA _tmp34_;
	GtkLabel* _tmp35_;
	GtkBox* _tmp36_;
	GtkLabel* _tmp37_;
	GtkMenuItem* _tmp38_;
	GtkMenuItem* result = NULL;
#line 462 "menubar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 464 "menubar.vala"
	_tmp0_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 464 "menubar.vala"
	g_object_ref_sink (_tmp0_);
#line 464 "menubar.vala"
	item = _tmp0_;
#line 465 "menubar.vala"
	_tmp1_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 3);
#line 465 "menubar.vala"
	g_object_ref_sink (_tmp1_);
#line 465 "menubar.vala"
	hbox = _tmp1_;
#line 466 "menubar.vala"
	_tmp2_ = hbox;
#line 466 "menubar.vala"
	gtk_widget_show ((GtkWidget*) _tmp2_);
#line 467 "menubar.vala"
	_tmp3_ = item;
#line 467 "menubar.vala"
	_tmp4_ = hbox;
#line 467 "menubar.vala"
	gtk_container_add ((GtkContainer*) _tmp3_, (GtkWidget*) _tmp4_);
#line 468 "menubar.vala"
	_tmp5_ = g_build_filename (PKGDATADIR, "keyboard.svg", NULL);
#line 468 "menubar.vala"
	_tmp6_ = _tmp5_;
#line 468 "menubar.vala"
	_tmp7_ = (GtkImage*) gtk_image_new_from_file (_tmp6_);
#line 468 "menubar.vala"
	g_object_ref_sink (_tmp7_);
#line 468 "menubar.vala"
	_tmp8_ = _tmp7_;
#line 468 "menubar.vala"
	_g_free0 (_tmp6_);
#line 468 "menubar.vala"
	image = _tmp8_;
#line 469 "menubar.vala"
	_tmp9_ = image;
#line 469 "menubar.vala"
	gtk_widget_show ((GtkWidget*) _tmp9_);
#line 470 "menubar.vala"
	_tmp10_ = hbox;
#line 470 "menubar.vala"
	_tmp11_ = image;
#line 470 "menubar.vala"
	gtk_container_add ((GtkContainer*) _tmp10_, (GtkWidget*) _tmp11_);
#line 471 "menubar.vala"
	_tmp12_ = hbox;
#line 471 "menubar.vala"
	gtk_box_set_spacing (_tmp12_, 6);
#line 472 "menubar.vala"
	_tmp13_ = (GtkLabel*) gtk_label_new ("");
#line 472 "menubar.vala"
	g_object_ref_sink (_tmp13_);
#line 472 "menubar.vala"
	label = _tmp13_;
#line 473 "menubar.vala"
	_tmp14_ = label;
#line 473 "menubar.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp14_, FALSE);
#line 474 "menubar.vala"
	_tmp15_ = lightdm_get_layout ();
#line 474 "menubar.vala"
	_tmp16_ = _g_object_ref0 (_tmp15_);
#line 474 "menubar.vala"
	current_layout = _tmp16_;
#line 475 "menubar.vala"
	_tmp17_ = current_layout;
#line 475 "menubar.vala"
	if (_tmp17_ != NULL) {
#line 4285 "menubar.c"
		GtkLabel* _tmp18_;
		LightDMLayout* _tmp19_;
		const gchar* _tmp20_;
		const gchar* _tmp21_;
		GtkMenuItem* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		LightDMLayout* _tmp25_;
		const gchar* _tmp26_;
		const gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
#line 476 "menubar.vala"
		_tmp18_ = label;
#line 476 "menubar.vala"
		_tmp19_ = current_layout;
#line 476 "menubar.vala"
		_tmp20_ = lightdm_layout_get_name (_tmp19_);
#line 476 "menubar.vala"
		_tmp21_ = _tmp20_;
#line 476 "menubar.vala"
		gtk_label_set_label (_tmp18_, _tmp21_);
#line 477 "menubar.vala"
		_tmp22_ = item;
#line 477 "menubar.vala"
		_tmp23_ = g_strconcat (_ ("Keyboard layout:"), " ", NULL);
#line 477 "menubar.vala"
		_tmp24_ = _tmp23_;
#line 477 "menubar.vala"
		_tmp25_ = current_layout;
#line 477 "menubar.vala"
		_tmp26_ = lightdm_layout_get_description (_tmp25_);
#line 477 "menubar.vala"
		_tmp27_ = _tmp26_;
#line 477 "menubar.vala"
		_tmp28_ = g_strconcat (_tmp24_, _tmp27_, NULL);
#line 477 "menubar.vala"
		_tmp29_ = _tmp28_;
#line 477 "menubar.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp22_, _tmp29_);
#line 477 "menubar.vala"
		_g_free0 (_tmp29_);
#line 477 "menubar.vala"
		_g_free0 (_tmp24_);
#line 4330 "menubar.c"
	}
#line 479 "menubar.vala"
	_tmp30_ = label;
#line 479 "menubar.vala"
	_tmp31_ = gtk_widget_get_style_context ((GtkWidget*) _tmp30_);
#line 479 "menubar.vala"
	gtk_style_context_get_color (_tmp31_, GTK_STATE_FLAG_NORMAL, &_tmp32_);
#line 479 "menubar.vala"
	keyboard_fg = _tmp32_;
#line 480 "menubar.vala"
	_tmp33_ = label;
#line 480 "menubar.vala"
	_tmp34_ = keyboard_fg;
#line 480 "menubar.vala"
	gtk_widget_override_color ((GtkWidget*) _tmp33_, GTK_STATE_FLAG_INSENSITIVE, &_tmp34_);
#line 481 "menubar.vala"
	_tmp35_ = label;
#line 481 "menubar.vala"
	gtk_widget_show ((GtkWidget*) _tmp35_);
#line 482 "menubar.vala"
	_tmp36_ = hbox;
#line 482 "menubar.vala"
	_tmp37_ = label;
#line 482 "menubar.vala"
	gtk_container_add ((GtkContainer*) _tmp36_, (GtkWidget*) _tmp37_);
#line 483 "menubar.vala"
	_tmp38_ = item;
#line 483 "menubar.vala"
	gtk_widget_show ((GtkWidget*) _tmp38_);
#line 485 "menubar.vala"
	result = item;
#line 485 "menubar.vala"
	_g_object_unref0 (current_layout);
#line 485 "menubar.vala"
	_g_object_unref0 (label);
#line 485 "menubar.vala"
	_g_object_unref0 (image);
#line 485 "menubar.vala"
	_g_object_unref0 (hbox);
#line 485 "menubar.vala"
	return result;
#line 4372 "menubar.c"
}

static void
menu_bar_shutdown_cb (MenuBar* self,
                      GtkMenuItem* item)
{
	MainWindow* _tmp0_;
#line 488 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 488 "menubar.vala"
	g_return_if_fail (item != NULL);
#line 490 "menubar.vala"
	_tmp0_ = self->priv->_main_window;
#line 490 "menubar.vala"
	if (_tmp0_ != NULL) {
#line 4388 "menubar.c"
		MainWindow* _tmp1_;
#line 491 "menubar.vala"
		_tmp1_ = self->priv->_main_window;
#line 491 "menubar.vala"
		main_window_show_shutdown_dialog (_tmp1_, SHUTDOWN_DIALOG_TYPE_RESTART);
#line 4394 "menubar.c"
	}
}

static void
menu_bar_keyboard_toggled_cb (MenuBar* self,
                              GtkCheckMenuItem* item)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	GtkWindow* _tmp2_;
	GtkWindow* _tmp39_;
	gboolean _tmp40_;
	gboolean _tmp41_;
	GError* _inner_error0_ = NULL;
#line 495 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 495 "menubar.vala"
	g_return_if_fail (item != NULL);
#line 503 "menubar.vala"
	_tmp0_ = gtk_check_menu_item_get_active (item);
#line 503 "menubar.vala"
	_tmp1_ = _tmp0_;
#line 503 "menubar.vala"
	ug_settings_set_boolean (UG_SETTINGS_KEY_ONSCREEN_KEYBOARD, _tmp1_);
#line 505 "menubar.vala"
	_tmp2_ = self->priv->_keyboard_window;
#line 505 "menubar.vala"
	if (_tmp2_ == NULL) {
#line 4423 "menubar.c"
		gint id = 0;
		GtkSocket* keyboard_socket = NULL;
		GtkSocket* _tmp16_;
		GtkSocket* _tmp17_;
		GtkWindow* _tmp18_;
		GtkWindow* _tmp19_;
		GtkWindow* _tmp20_;
		GtkWindow* _tmp21_;
		GtkWindow* _tmp22_;
		GtkSocket* _tmp23_;
		GtkSocket* _tmp24_;
		GdkDisplay* display = NULL;
		GdkDisplay* _tmp25_;
		GdkDisplay* _tmp26_;
		GdkMonitor* monitor = NULL;
		GdkDisplay* _tmp27_;
		GdkWindow* _tmp28_;
		GdkMonitor* _tmp29_;
		GdkMonitor* _tmp30_;
		GdkRectangle geom = {0};
		GdkMonitor* _tmp31_;
		GdkRectangle _tmp32_ = {0};
		GtkWindow* _tmp33_;
		GdkRectangle _tmp34_;
		GdkRectangle _tmp35_;
		GdkRectangle _tmp36_;
		GtkWindow* _tmp37_;
		GdkRectangle _tmp38_;
#line 507 "menubar.vala"
		id = 0;
#line 4454 "menubar.c"
		{
			gchar** argv = NULL;
			gint argv_length1 = 0;
			gint _argv_size_ = 0;
			gint onboard_stdout_fd = 0;
			gchar** _tmp3_ = NULL;
			gint _tmp4_ = 0;
			gchar** _tmp5_;
			gint _tmp5__length1;
			GPid _tmp6_ = 0;
			gint _tmp7_ = 0;
			FILE* f = NULL;
			FILE* _tmp8_;
			gchar* stdout_text = NULL;
			gchar* _tmp9_;
			gint stdout_text_length1;
			gint _stdout_text_size_;
			FILE* _tmp10_;
			gchar* _tmp11_;
			gint _tmp11__length1;
			const gchar* _tmp12_;
#line 514 "menubar.vala"
			g_shell_parse_argv ("onboard --xid", &_tmp4_, &_tmp3_, &_inner_error0_);
#line 514 "menubar.vala"
			argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 514 "menubar.vala"
			argv = _tmp3_;
#line 514 "menubar.vala"
			argv_length1 = _tmp4_;
#line 514 "menubar.vala"
			_argv_size_ = argv_length1;
#line 514 "menubar.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 514 "menubar.vala"
				argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 4490 "menubar.c"
				goto __catch0_g_error;
			}
#line 515 "menubar.vala"
			_tmp5_ = argv;
#line 515 "menubar.vala"
			_tmp5__length1 = argv_length1;
#line 515 "menubar.vala"
			g_spawn_async_with_pipes (NULL, _tmp5_, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp6_, NULL, &_tmp7_, NULL, &_inner_error0_);
#line 515 "menubar.vala"
			self->priv->keyboard_pid = _tmp6_;
#line 515 "menubar.vala"
			onboard_stdout_fd = _tmp7_;
#line 515 "menubar.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 515 "menubar.vala"
				argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 4507 "menubar.c"
				goto __catch0_g_error;
			}
#line 524 "menubar.vala"
			_tmp8_ = fdopen (onboard_stdout_fd, "r");
#line 524 "menubar.vala"
			f = _tmp8_;
#line 525 "menubar.vala"
			_tmp9_ = g_new0 (gchar, 1024);
#line 525 "menubar.vala"
			stdout_text = _tmp9_;
#line 525 "menubar.vala"
			stdout_text_length1 = 1024;
#line 525 "menubar.vala"
			_stdout_text_size_ = stdout_text_length1;
#line 526 "menubar.vala"
			_tmp10_ = f;
#line 526 "menubar.vala"
			_tmp11_ = stdout_text;
#line 526 "menubar.vala"
			_tmp11__length1 = stdout_text_length1;
#line 526 "menubar.vala"
			_tmp12_ = fgets (_tmp11_, (gint) _tmp11__length1, _tmp10_);
#line 526 "menubar.vala"
			if (_tmp12_ != NULL) {
#line 4532 "menubar.c"
				gchar* _tmp13_;
				gint _tmp13__length1;
#line 527 "menubar.vala"
				_tmp13_ = stdout_text;
#line 527 "menubar.vala"
				_tmp13__length1 = stdout_text_length1;
#line 527 "menubar.vala"
				id = atoi ((const gchar*) _tmp13_);
#line 4541 "menubar.c"
			}
#line 509 "menubar.vala"
			stdout_text = (g_free (stdout_text), NULL);
#line 509 "menubar.vala"
			_fclose0 (f);
#line 509 "menubar.vala"
			argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 4549 "menubar.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp14_;
			const gchar* _tmp15_;
#line 509 "menubar.vala"
			e = _inner_error0_;
#line 509 "menubar.vala"
			_inner_error0_ = NULL;
#line 532 "menubar.vala"
			_tmp14_ = e;
#line 532 "menubar.vala"
			_tmp15_ = _tmp14_->message;
#line 532 "menubar.vala"
			g_warning ("menubar.vala:532: Error setting up keyboard: %s", _tmp15_);
#line 533 "menubar.vala"
			_g_error_free0 (e);
#line 533 "menubar.vala"
			return;
#line 4571 "menubar.c"
		}
		__finally0:
#line 509 "menubar.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 509 "menubar.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 509 "menubar.vala"
			g_clear_error (&_inner_error0_);
#line 509 "menubar.vala"
			return;
#line 4582 "menubar.c"
		}
#line 536 "menubar.vala"
		_tmp16_ = (GtkSocket*) gtk_socket_new ();
#line 536 "menubar.vala"
		g_object_ref_sink (_tmp16_);
#line 536 "menubar.vala"
		keyboard_socket = _tmp16_;
#line 537 "menubar.vala"
		_tmp17_ = keyboard_socket;
#line 537 "menubar.vala"
		gtk_widget_show ((GtkWidget*) _tmp17_);
#line 538 "menubar.vala"
		_tmp18_ = (GtkWindow*) gtk_window_new (GTK_WINDOW_TOPLEVEL);
#line 538 "menubar.vala"
		g_object_ref_sink (_tmp18_);
#line 538 "menubar.vala"
		_tmp19_ = _tmp18_;
#line 538 "menubar.vala"
		menu_bar_set_keyboard_window (self, _tmp19_);
#line 538 "menubar.vala"
		_g_object_unref0 (_tmp19_);
#line 539 "menubar.vala"
		_tmp20_ = self->priv->_keyboard_window;
#line 539 "menubar.vala"
		gtk_window_set_accept_focus (_tmp20_, FALSE);
#line 540 "menubar.vala"
		_tmp21_ = self->priv->_keyboard_window;
#line 540 "menubar.vala"
		gtk_window_set_focus_on_map (_tmp21_, FALSE);
#line 541 "menubar.vala"
		_tmp22_ = self->priv->_keyboard_window;
#line 541 "menubar.vala"
		_tmp23_ = keyboard_socket;
#line 541 "menubar.vala"
		gtk_container_add ((GtkContainer*) _tmp22_, (GtkWidget*) _tmp23_);
#line 542 "menubar.vala"
		_tmp24_ = keyboard_socket;
#line 542 "menubar.vala"
		gtk_socket_add_id (_tmp24_, (Window) id);
#line 545 "menubar.vala"
		_tmp25_ = gtk_widget_get_display ((GtkWidget*) self);
#line 545 "menubar.vala"
		_tmp26_ = _g_object_ref0 (_tmp25_);
#line 545 "menubar.vala"
		display = _tmp26_;
#line 546 "menubar.vala"
		_tmp27_ = display;
#line 546 "menubar.vala"
		_tmp28_ = gtk_widget_get_window ((GtkWidget*) self);
#line 546 "menubar.vala"
		_tmp29_ = gdk_display_get_monitor_at_window (_tmp27_, _tmp28_);
#line 546 "menubar.vala"
		_tmp30_ = _g_object_ref0 (_tmp29_);
#line 546 "menubar.vala"
		monitor = _tmp30_;
#line 548 "menubar.vala"
		_tmp31_ = monitor;
#line 548 "menubar.vala"
		gdk_monitor_get_geometry (_tmp31_, &_tmp32_);
#line 548 "menubar.vala"
		geom = _tmp32_;
#line 549 "menubar.vala"
		_tmp33_ = self->priv->_keyboard_window;
#line 549 "menubar.vala"
		_tmp34_ = geom;
#line 549 "menubar.vala"
		_tmp35_ = geom;
#line 549 "menubar.vala"
		_tmp36_ = geom;
#line 549 "menubar.vala"
		gtk_window_move (_tmp33_, _tmp34_.x, (_tmp35_.y + _tmp36_.height) - 250);
#line 550 "menubar.vala"
		_tmp37_ = self->priv->_keyboard_window;
#line 550 "menubar.vala"
		_tmp38_ = geom;
#line 550 "menubar.vala"
		gtk_window_resize (_tmp37_, _tmp38_.width, 250);
#line 505 "menubar.vala"
		_g_object_unref0 (monitor);
#line 505 "menubar.vala"
		_g_object_unref0 (display);
#line 505 "menubar.vala"
		_g_object_unref0 (keyboard_socket);
#line 4666 "menubar.c"
	}
#line 553 "menubar.vala"
	_tmp39_ = self->priv->_keyboard_window;
#line 553 "menubar.vala"
	_tmp40_ = gtk_check_menu_item_get_active (item);
#line 553 "menubar.vala"
	_tmp41_ = _tmp40_;
#line 553 "menubar.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp39_, _tmp41_);
#line 4676 "menubar.c"
}

static void
menu_bar_high_contrast_toggled_cb (MenuBar* self,
                                   GtkCheckMenuItem* item)
{
	GtkSettings* settings = NULL;
	GtkSettings* _tmp0_;
	GtkSettings* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
#line 556 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 556 "menubar.vala"
	g_return_if_fail (item != NULL);
#line 558 "menubar.vala"
	_tmp0_ = gtk_settings_get_default ();
#line 558 "menubar.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 558 "menubar.vala"
	settings = _tmp1_;
#line 559 "menubar.vala"
	_tmp2_ = gtk_check_menu_item_get_active (item);
#line 559 "menubar.vala"
	_tmp3_ = _tmp2_;
#line 559 "menubar.vala"
	if (_tmp3_) {
#line 4707 "menubar.c"
		GtkSettings* _tmp4_;
#line 560 "menubar.vala"
		_tmp4_ = settings;
#line 560 "menubar.vala"
		g_object_set ((GObject*) _tmp4_, "gtk-theme-name", "HighContrast", NULL);
#line 4713 "menubar.c"
	} else {
		GtkSettings* _tmp5_;
		const gchar* _tmp6_;
#line 562 "menubar.vala"
		_tmp5_ = settings;
#line 562 "menubar.vala"
		_tmp6_ = self->priv->default_theme_name;
#line 562 "menubar.vala"
		g_object_set ((GObject*) _tmp5_, "gtk-theme-name", _tmp6_, NULL);
#line 4723 "menubar.c"
	}
#line 563 "menubar.vala"
	_tmp7_ = gtk_check_menu_item_get_active (item);
#line 563 "menubar.vala"
	_tmp8_ = _tmp7_;
#line 563 "menubar.vala"
	menu_bar_set_high_contrast (self, _tmp8_);
#line 564 "menubar.vala"
	_tmp9_ = self->priv->_high_contrast;
#line 564 "menubar.vala"
	ug_settings_set_boolean (UG_SETTINGS_KEY_HIGH_CONTRAST, _tmp9_);
#line 556 "menubar.vala"
	_g_object_unref0 (settings);
#line 4737 "menubar.c"
}

static gboolean
____lambda5_ (MenuBar* self)
{
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	AtkObject* _tmp2_;
	gboolean result = FALSE;
#line 597 "menubar.vala"
	_tmp0_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 597 "menubar.vala"
	_tmp1_ = gtk_window_get_focus (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, gtk_window_get_type ()) ? ((GtkWindow*) _tmp0_) : NULL);
#line 597 "menubar.vala"
	_tmp2_ = gtk_widget_get_accessible (_tmp1_);
#line 597 "menubar.vala"
	g_signal_emit_by_name (_tmp2_, "focus-event", TRUE, NULL);
#line 598 "menubar.vala"
	result = FALSE;
#line 598 "menubar.vala"
	return result;
#line 4759 "menubar.c"
}

static gboolean
_____lambda5__gsource_func (gpointer self)
{
	gboolean result;
	result = ____lambda5_ ((MenuBar*) self);
#line 596 "menubar.vala"
	return result;
#line 4769 "menubar.c"
}

static void
menu_bar_screen_reader_toggled_cb (MenuBar* self,
                                   GtkCheckMenuItem* item)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GError* _inner_error0_ = NULL;
#line 567 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 567 "menubar.vala"
	g_return_if_fail (item != NULL);
#line 569 "menubar.vala"
	_tmp0_ = gtk_check_menu_item_get_active (item);
#line 569 "menubar.vala"
	_tmp1_ = _tmp0_;
#line 569 "menubar.vala"
	ug_settings_set_boolean (UG_SETTINGS_KEY_SCREEN_READER, _tmp1_);
#line 571 "menubar.vala"
	_tmp2_ = gtk_check_menu_item_get_active (item);
#line 571 "menubar.vala"
	_tmp3_ = _tmp2_;
#line 571 "menubar.vala"
	if (_tmp3_) {
#line 4797 "menubar.c"
		{
			gchar** argv = NULL;
			gint argv_length1 = 0;
			gint _argv_size_ = 0;
			gchar** _tmp4_ = NULL;
			gint _tmp5_ = 0;
			gchar** _tmp6_;
			gint _tmp6__length1;
			GPid _tmp7_ = 0;
			SlickGreeter* _tmp8_;
#line 576 "menubar.vala"
			g_shell_parse_argv ("orca --replace", &_tmp5_, &_tmp4_, &_inner_error0_);
#line 576 "menubar.vala"
			argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 576 "menubar.vala"
			argv = _tmp4_;
#line 576 "menubar.vala"
			argv_length1 = _tmp5_;
#line 576 "menubar.vala"
			_argv_size_ = argv_length1;
#line 576 "menubar.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 576 "menubar.vala"
				argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 4822 "menubar.c"
				goto __catch0_g_error;
			}
#line 577 "menubar.vala"
			_tmp6_ = argv;
#line 577 "menubar.vala"
			_tmp6__length1 = argv_length1;
#line 577 "menubar.vala"
			g_spawn_async (NULL, _tmp6_, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp7_, &_inner_error0_);
#line 577 "menubar.vala"
			self->priv->reader_pid = _tmp7_;
#line 577 "menubar.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 577 "menubar.vala"
				argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 4837 "menubar.c"
				goto __catch0_g_error;
			}
#line 595 "menubar.vala"
			_tmp8_ = slick_greeter_singleton;
#line 595 "menubar.vala"
			_tmp8_->orca_needs_kick = TRUE;
#line 596 "menubar.vala"
			g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 1, _____lambda5__gsource_func, g_object_ref (self), g_object_unref);
#line 573 "menubar.vala"
			argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 4848 "menubar.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp9_;
			const gchar* _tmp10_;
#line 573 "menubar.vala"
			e = _inner_error0_;
#line 573 "menubar.vala"
			_inner_error0_ = NULL;
#line 603 "menubar.vala"
			_tmp9_ = e;
#line 603 "menubar.vala"
			_tmp10_ = _tmp9_->message;
#line 603 "menubar.vala"
			g_warning ("menubar.vala:603: Failed to run Orca: %s", _tmp10_);
#line 573 "menubar.vala"
			_g_error_free0 (e);
#line 4868 "menubar.c"
		}
		__finally0:
#line 573 "menubar.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 573 "menubar.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 573 "menubar.vala"
			g_clear_error (&_inner_error0_);
#line 573 "menubar.vala"
			return;
#line 4879 "menubar.c"
		}
	} else {
#line 607 "menubar.vala"
		menu_bar_close_pid (self, &self->priv->reader_pid);
#line 4884 "menubar.c"
	}
}

Background*
menu_bar_get_background (MenuBar* self)
{
	Background* result;
	Background* _tmp0_;
#line 80 "menubar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 80 "menubar.vala"
	_tmp0_ = self->priv->_background;
#line 80 "menubar.vala"
	result = _tmp0_;
#line 80 "menubar.vala"
	return result;
#line 4901 "menubar.c"
}

static void
menu_bar_set_background (MenuBar* self,
                         Background* value)
{
	Background* old_value;
#line 80 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 80 "menubar.vala"
	old_value = menu_bar_get_background (self);
#line 80 "menubar.vala"
	if (old_value != value) {
#line 4915 "menubar.c"
		Background* _tmp0_;
#line 80 "menubar.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 80 "menubar.vala"
		_g_object_unref0 (self->priv->_background);
#line 80 "menubar.vala"
		self->priv->_background = _tmp0_;
#line 80 "menubar.vala"
		g_object_notify_by_pspec ((GObject *) self, menu_bar_properties[MENU_BAR_BACKGROUND_PROPERTY]);
#line 4925 "menubar.c"
	}
}

gboolean
menu_bar_get_high_contrast (MenuBar* self)
{
	gboolean result;
#line 81 "menubar.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 81 "menubar.vala"
	result = self->priv->_high_contrast;
#line 81 "menubar.vala"
	return result;
#line 4939 "menubar.c"
}

static void
menu_bar_set_high_contrast (MenuBar* self,
                            gboolean value)
{
	gboolean old_value;
#line 81 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 81 "menubar.vala"
	old_value = menu_bar_get_high_contrast (self);
#line 81 "menubar.vala"
	if (old_value != value) {
#line 81 "menubar.vala"
		self->priv->_high_contrast = value;
#line 81 "menubar.vala"
		g_object_notify_by_pspec ((GObject *) self, menu_bar_properties[MENU_BAR_HIGH_CONTRAST_PROPERTY]);
#line 4957 "menubar.c"
	}
}

GtkWindow*
menu_bar_get_keyboard_window (MenuBar* self)
{
	GtkWindow* result;
	GtkWindow* _tmp0_;
#line 82 "menubar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 82 "menubar.vala"
	_tmp0_ = self->priv->_keyboard_window;
#line 82 "menubar.vala"
	result = _tmp0_;
#line 82 "menubar.vala"
	return result;
#line 4974 "menubar.c"
}

static void
menu_bar_set_keyboard_window (MenuBar* self,
                              GtkWindow* value)
{
	GtkWindow* old_value;
#line 82 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 82 "menubar.vala"
	old_value = menu_bar_get_keyboard_window (self);
#line 82 "menubar.vala"
	if (old_value != value) {
#line 4988 "menubar.c"
		GtkWindow* _tmp0_;
#line 82 "menubar.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 82 "menubar.vala"
		_g_object_unref0 (self->priv->_keyboard_window);
#line 82 "menubar.vala"
		self->priv->_keyboard_window = _tmp0_;
#line 82 "menubar.vala"
		g_object_notify_by_pspec ((GObject *) self, menu_bar_properties[MENU_BAR_KEYBOARD_WINDOW_PROPERTY]);
#line 4998 "menubar.c"
	}
}

GtkAccelGroup*
menu_bar_get_accel_group (MenuBar* self)
{
	GtkAccelGroup* result;
	GtkAccelGroup* _tmp0_;
#line 83 "menubar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 83 "menubar.vala"
	_tmp0_ = self->priv->_accel_group;
#line 83 "menubar.vala"
	result = _tmp0_;
#line 83 "menubar.vala"
	return result;
#line 5015 "menubar.c"
}

static void
menu_bar_set_accel_group (MenuBar* self,
                          GtkAccelGroup* value)
{
	GtkAccelGroup* old_value;
#line 83 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 83 "menubar.vala"
	old_value = menu_bar_get_accel_group (self);
#line 83 "menubar.vala"
	if (old_value != value) {
#line 5029 "menubar.c"
		GtkAccelGroup* _tmp0_;
#line 83 "menubar.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 83 "menubar.vala"
		_g_object_unref0 (self->priv->_accel_group);
#line 83 "menubar.vala"
		self->priv->_accel_group = _tmp0_;
#line 83 "menubar.vala"
		g_object_notify_by_pspec ((GObject *) self, menu_bar_properties[MENU_BAR_ACCEL_GROUP_PROPERTY]);
#line 5039 "menubar.c"
	}
}

MainWindow*
menu_bar_get_main_window (MenuBar* self)
{
	MainWindow* result;
	MainWindow* _tmp0_;
#line 84 "menubar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 84 "menubar.vala"
	_tmp0_ = self->priv->_main_window;
#line 84 "menubar.vala"
	result = _tmp0_;
#line 84 "menubar.vala"
	return result;
#line 5056 "menubar.c"
}

static void
menu_bar_set_main_window (MenuBar* self,
                          MainWindow* value)
{
	MainWindow* old_value;
#line 84 "menubar.vala"
	g_return_if_fail (self != NULL);
#line 84 "menubar.vala"
	old_value = menu_bar_get_main_window (self);
#line 84 "menubar.vala"
	if (old_value != value) {
#line 5070 "menubar.c"
		MainWindow* _tmp0_;
#line 84 "menubar.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 84 "menubar.vala"
		_g_object_unref0 (self->priv->_main_window);
#line 84 "menubar.vala"
		self->priv->_main_window = _tmp0_;
#line 84 "menubar.vala"
		g_object_notify_by_pspec ((GObject *) self, menu_bar_properties[MENU_BAR_MAIN_WINDOW_PROPERTY]);
#line 5080 "menubar.c"
	}
}

static gboolean
_menu_bar_update_clock_gsource_func (gpointer self)
{
	gboolean result;
	result = menu_bar_update_clock ((MenuBar*) self);
#line 163 "menubar.vala"
	return result;
#line 5091 "menubar.c"
}

static void
_menu_bar_on_power_device_added_upower_daemon_device_added (UPowerDaemon* _sender,
                                                            const char* device,
                                                            gpointer self)
{
#line 188 "menubar.vala"
	menu_bar_on_power_device_added ((MenuBar*) self, device);
#line 5101 "menubar.c"
}

static void
_menu_bar_on_power_device_removed_upower_daemon_device_removed (UPowerDaemon* _sender,
                                                                const char* device,
                                                                gpointer self)
{
#line 189 "menubar.vala"
	menu_bar_on_power_device_removed ((MenuBar*) self, device);
#line 5111 "menubar.c"
}

static void
_menu_bar_on_power_device_changed_upower_daemon_device_changed (UPowerDaemon* _sender,
                                                                const char* device,
                                                                gpointer self)
{
#line 190 "menubar.vala"
	menu_bar_on_power_device_changed ((MenuBar*) self, device);
#line 5121 "menubar.c"
}

static void
_menu_bar_on_changed_upower_daemon_changed (UPowerDaemon* _sender,
                                            gpointer self)
{
#line 191 "menubar.vala"
	menu_bar_on_changed ((MenuBar*) self);
#line 5130 "menubar.c"
}

static void
_menu_bar_on_sleeping_upower_daemon_sleeping (UPowerDaemon* _sender,
                                              gpointer self)
{
#line 192 "menubar.vala"
	menu_bar_on_sleeping ((MenuBar*) self);
#line 5139 "menubar.c"
}

static void
_menu_bar_on_resuming_upower_daemon_resuming (UPowerDaemon* _sender,
                                              gpointer self)
{
#line 193 "menubar.vala"
	menu_bar_on_resuming ((MenuBar*) self);
#line 5148 "menubar.c"
}

static gboolean
_menu_bar_query_upower_daemon_gsource_func (gpointer self)
{
	gboolean result;
	result = menu_bar_query_upower_daemon ((MenuBar*) self);
#line 195 "menubar.vala"
	return result;
#line 5158 "menubar.c"
}

static void
_menu_bar_cleanup_slick_greeter_starting_session (SlickGreeter* _sender,
                                                  gpointer self)
{
#line 240 "menubar.vala"
	menu_bar_cleanup ((MenuBar*) self);
#line 5167 "menubar.c"
}

static GObject *
menu_bar_constructor (GType type,
                      guint n_construct_properties,
                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MenuBar * self;
	GtkSettings* _tmp0_;
	gchar* _tmp1_ = NULL;
	SlickGreeter* _tmp79_;
	GError* _inner_error0_ = NULL;
#line 138 "menubar.vala"
	parent_class = G_OBJECT_CLASS (menu_bar_parent_class);
#line 138 "menubar.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 138 "menubar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MENU_BAR, MenuBar);
#line 140 "menubar.vala"
	_tmp0_ = gtk_settings_get_default ();
#line 140 "menubar.vala"
	g_object_get ((GObject*) _tmp0_, "gtk-theme-name", &_tmp1_, NULL);
#line 140 "menubar.vala"
	_g_free0 (self->priv->default_theme_name);
#line 140 "menubar.vala"
	self->priv->default_theme_name = _tmp1_;
#line 142 "menubar.vala"
	gtk_menu_bar_set_pack_direction ((GtkMenuBar*) self, GTK_PACK_DIRECTION_RTL);
#line 144 "menubar.vala"
	if (ug_settings_get_boolean (UG_SETTINGS_KEY_SHOW_QUIT)) {
#line 5200 "menubar.c"
		GtkMenuItem* session_menu = NULL;
		GtkMenuItem* _tmp2_;
		GtkMenuItem* _tmp3_;
#line 146 "menubar.vala"
		_tmp2_ = menu_bar_make_session_item (self);
#line 146 "menubar.vala"
		session_menu = _tmp2_;
#line 147 "menubar.vala"
		_tmp3_ = session_menu;
#line 147 "menubar.vala"
		gtk_menu_shell_append ((GtkMenuShell*) self, _tmp3_);
#line 144 "menubar.vala"
		_g_object_unref0 (session_menu);
#line 5214 "menubar.c"
	}
#line 150 "menubar.vala"
	if (ug_settings_get_boolean (UG_SETTINGS_KEY_SHOW_CLOCK)) {
#line 5218 "menubar.c"
		GtkLabel* _tmp4_;
		GdkRGBA clock_fg = {0};
		GtkLabel* _tmp5_;
		GtkStyleContext* _tmp6_;
		GdkRGBA _tmp7_ = {0};
		GtkLabel* _tmp8_;
		GdkRGBA _tmp9_;
		GtkLabel* _tmp10_;
		GtkMenuItem* item = NULL;
		GtkMenuItem* _tmp11_;
		GtkMenuItem* _tmp12_;
		GtkLabel* _tmp13_;
		GtkMenuItem* _tmp14_;
		GtkMenuItem* _tmp15_;
		GtkMenuItem* _tmp16_;
		gchar* _tmp17_;
#line 152 "menubar.vala"
		_tmp4_ = (GtkLabel*) gtk_label_new ("");
#line 152 "menubar.vala"
		g_object_ref_sink (_tmp4_);
#line 152 "menubar.vala"
		_g_object_unref0 (self->priv->clock_label);
#line 152 "menubar.vala"
		self->priv->clock_label = _tmp4_;
#line 153 "menubar.vala"
		_tmp5_ = self->priv->clock_label;
#line 153 "menubar.vala"
		_tmp6_ = gtk_widget_get_style_context ((GtkWidget*) _tmp5_);
#line 153 "menubar.vala"
		gtk_style_context_get_color (_tmp6_, GTK_STATE_FLAG_NORMAL, &_tmp7_);
#line 153 "menubar.vala"
		clock_fg = _tmp7_;
#line 154 "menubar.vala"
		_tmp8_ = self->priv->clock_label;
#line 154 "menubar.vala"
		_tmp9_ = clock_fg;
#line 154 "menubar.vala"
		gtk_widget_override_color ((GtkWidget*) _tmp8_, GTK_STATE_FLAG_INSENSITIVE, &_tmp9_);
#line 155 "menubar.vala"
		_tmp10_ = self->priv->clock_label;
#line 155 "menubar.vala"
		gtk_widget_show ((GtkWidget*) _tmp10_);
#line 156 "menubar.vala"
		_tmp11_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 156 "menubar.vala"
		g_object_ref_sink (_tmp11_);
#line 156 "menubar.vala"
		item = _tmp11_;
#line 157 "menubar.vala"
		_tmp12_ = item;
#line 157 "menubar.vala"
		_tmp13_ = self->priv->clock_label;
#line 157 "menubar.vala"
		gtk_container_add ((GtkContainer*) _tmp12_, (GtkWidget*) _tmp13_);
#line 158 "menubar.vala"
		_tmp14_ = item;
#line 158 "menubar.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp14_, FALSE);
#line 159 "menubar.vala"
		_tmp15_ = item;
#line 159 "menubar.vala"
		gtk_widget_show ((GtkWidget*) _tmp15_);
#line 160 "menubar.vala"
		_tmp16_ = item;
#line 160 "menubar.vala"
		gtk_menu_shell_append ((GtkMenuShell*) self, _tmp16_);
#line 161 "menubar.vala"
		_tmp17_ = ug_settings_get_string (UG_SETTINGS_KEY_CLOCK_FORMAT);
#line 161 "menubar.vala"
		_g_free0 (self->priv->clock_format);
#line 161 "menubar.vala"
		self->priv->clock_format = _tmp17_;
#line 162 "menubar.vala"
		menu_bar_update_clock (self);
#line 163 "menubar.vala"
		g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 1000, _menu_bar_update_clock_gsource_func, g_object_ref (self), g_object_unref);
#line 150 "menubar.vala"
		_g_object_unref0 (item);
#line 5297 "menubar.c"
	}
#line 166 "menubar.vala"
	if (ug_settings_get_boolean (UG_SETTINGS_KEY_SHOW_POWER)) {
#line 5301 "menubar.c"
		GtkMenuItem* _tmp18_;
		GtkBox* hbox = NULL;
		GtkBox* _tmp19_;
		GtkBox* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		GtkImage* _tmp23_;
		GtkImage* _tmp24_;
		GtkBox* _tmp25_;
		GtkImage* _tmp26_;
		GtkBox* _tmp27_;
		GtkLabel* _tmp28_;
		GtkLabel* _tmp29_;
		GdkRGBA power_fg = {0};
		GtkLabel* _tmp30_;
		GtkStyleContext* _tmp31_;
		GdkRGBA _tmp32_ = {0};
		GtkLabel* _tmp33_;
		GdkRGBA _tmp34_;
		GtkLabel* _tmp35_;
		GtkBox* _tmp36_;
		GtkLabel* _tmp37_;
		GtkMenuItem* _tmp38_;
		GtkBox* _tmp39_;
		GtkMenuItem* _tmp40_;
		GtkMenuItem* _tmp41_;
#line 168 "menubar.vala"
		_tmp18_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 168 "menubar.vala"
		g_object_ref_sink (_tmp18_);
#line 168 "menubar.vala"
		_g_object_unref0 (self->priv->power_menu_item);
#line 168 "menubar.vala"
		self->priv->power_menu_item = _tmp18_;
#line 169 "menubar.vala"
		_tmp19_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 3);
#line 169 "menubar.vala"
		g_object_ref_sink (_tmp19_);
#line 169 "menubar.vala"
		hbox = _tmp19_;
#line 170 "menubar.vala"
		_tmp20_ = hbox;
#line 170 "menubar.vala"
		gtk_widget_show ((GtkWidget*) _tmp20_);
#line 171 "menubar.vala"
		_tmp21_ = g_build_filename (PKGDATADIR, "battery.svg", NULL);
#line 171 "menubar.vala"
		_tmp22_ = _tmp21_;
#line 171 "menubar.vala"
		_tmp23_ = (GtkImage*) gtk_image_new_from_file (_tmp22_);
#line 171 "menubar.vala"
		g_object_ref_sink (_tmp23_);
#line 171 "menubar.vala"
		_g_object_unref0 (self->priv->power_icon);
#line 171 "menubar.vala"
		self->priv->power_icon = _tmp23_;
#line 171 "menubar.vala"
		_g_free0 (_tmp22_);
#line 172 "menubar.vala"
		_tmp24_ = self->priv->power_icon;
#line 172 "menubar.vala"
		gtk_widget_show ((GtkWidget*) _tmp24_);
#line 173 "menubar.vala"
		_tmp25_ = hbox;
#line 173 "menubar.vala"
		_tmp26_ = self->priv->power_icon;
#line 173 "menubar.vala"
		gtk_container_add ((GtkContainer*) _tmp25_, (GtkWidget*) _tmp26_);
#line 174 "menubar.vala"
		_tmp27_ = hbox;
#line 174 "menubar.vala"
		gtk_box_set_spacing (_tmp27_, 6);
#line 175 "menubar.vala"
		_tmp28_ = (GtkLabel*) gtk_label_new ("");
#line 175 "menubar.vala"
		g_object_ref_sink (_tmp28_);
#line 175 "menubar.vala"
		_g_object_unref0 (self->priv->power_label);
#line 175 "menubar.vala"
		self->priv->power_label = _tmp28_;
#line 176 "menubar.vala"
		_tmp29_ = self->priv->power_label;
#line 176 "menubar.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp29_, FALSE);
#line 177 "menubar.vala"
		_tmp30_ = self->priv->power_label;
#line 177 "menubar.vala"
		_tmp31_ = gtk_widget_get_style_context ((GtkWidget*) _tmp30_);
#line 177 "menubar.vala"
		gtk_style_context_get_color (_tmp31_, GTK_STATE_FLAG_NORMAL, &_tmp32_);
#line 177 "menubar.vala"
		power_fg = _tmp32_;
#line 178 "menubar.vala"
		_tmp33_ = self->priv->power_label;
#line 178 "menubar.vala"
		_tmp34_ = power_fg;
#line 178 "menubar.vala"
		gtk_widget_override_color ((GtkWidget*) _tmp33_, GTK_STATE_FLAG_INSENSITIVE, &_tmp34_);
#line 179 "menubar.vala"
		_tmp35_ = self->priv->power_label;
#line 179 "menubar.vala"
		gtk_widget_show ((GtkWidget*) _tmp35_);
#line 180 "menubar.vala"
		_tmp36_ = hbox;
#line 180 "menubar.vala"
		_tmp37_ = self->priv->power_label;
#line 180 "menubar.vala"
		gtk_container_add ((GtkContainer*) _tmp36_, (GtkWidget*) _tmp37_);
#line 181 "menubar.vala"
		_tmp38_ = self->priv->power_menu_item;
#line 181 "menubar.vala"
		_tmp39_ = hbox;
#line 181 "menubar.vala"
		gtk_container_add ((GtkContainer*) _tmp38_, (GtkWidget*) _tmp39_);
#line 182 "menubar.vala"
		_tmp40_ = self->priv->power_menu_item;
#line 182 "menubar.vala"
		gtk_widget_hide ((GtkWidget*) _tmp40_);
#line 183 "menubar.vala"
		_tmp41_ = self->priv->power_menu_item;
#line 183 "menubar.vala"
		gtk_menu_shell_append ((GtkMenuShell*) self, _tmp41_);
#line 5424 "menubar.c"
		{
			UPowerDaemon* _tmp42_ = NULL;
			UPowerDaemon* _tmp43_;
			UPowerDaemon* _tmp44_;
			UPowerDaemon* _tmp45_;
			UPowerDaemon* _tmp46_;
			UPowerDaemon* _tmp47_;
			UPowerDaemon* _tmp48_;
			UPowerDaemon* _tmp49_;
			UPowerDaemon* _tmp50_;
#line 187 "menubar.vala"
			_tmp43_ = (UPowerDaemon*) g_initable_new (UPOWER_TYPE_DAEMON_PROXY, NULL, &_inner_error0_, "g-flags", 0, "g-name", "org.freedesktop.UPower", "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", "/org/freedesktop/UPower", "g-interface-name", "org.freedesktop.UPower", NULL);
#line 187 "menubar.vala"
			_tmp42_ = (UPowerDaemon*) _tmp43_;
#line 187 "menubar.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 187 "menubar.vala"
				if (_inner_error0_->domain == G_IO_ERROR) {
#line 5443 "menubar.c"
					goto __catch0_g_io_error;
				}
#line 187 "menubar.vala"
				_g_object_unref0 (hbox);
#line 187 "menubar.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 187 "menubar.vala"
				g_clear_error (&_inner_error0_);
#line 5452 "menubar.c"
			}
#line 187 "menubar.vala"
			_tmp44_ = _tmp42_;
#line 187 "menubar.vala"
			_tmp42_ = NULL;
#line 187 "menubar.vala"
			_g_object_unref0 (self->priv->upowerd);
#line 187 "menubar.vala"
			self->priv->upowerd = _tmp44_;
#line 188 "menubar.vala"
			_tmp45_ = self->priv->upowerd;
#line 188 "menubar.vala"
			g_signal_connect_object (_tmp45_, "device-added", (GCallback) _menu_bar_on_power_device_added_upower_daemon_device_added, self, 0);
#line 189 "menubar.vala"
			_tmp46_ = self->priv->upowerd;
#line 189 "menubar.vala"
			g_signal_connect_object (_tmp46_, "device-removed", (GCallback) _menu_bar_on_power_device_removed_upower_daemon_device_removed, self, 0);
#line 190 "menubar.vala"
			_tmp47_ = self->priv->upowerd;
#line 190 "menubar.vala"
			g_signal_connect_object (_tmp47_, "device-changed", (GCallback) _menu_bar_on_power_device_changed_upower_daemon_device_changed, self, 0);
#line 191 "menubar.vala"
			_tmp48_ = self->priv->upowerd;
#line 191 "menubar.vala"
			g_signal_connect_object (_tmp48_, "changed", (GCallback) _menu_bar_on_changed_upower_daemon_changed, self, 0);
#line 192 "menubar.vala"
			_tmp49_ = self->priv->upowerd;
#line 192 "menubar.vala"
			g_signal_connect_object (_tmp49_, "sleeping", (GCallback) _menu_bar_on_sleeping_upower_daemon_sleeping, self, 0);
#line 193 "menubar.vala"
			_tmp50_ = self->priv->upowerd;
#line 193 "menubar.vala"
			g_signal_connect_object (_tmp50_, "resuming", (GCallback) _menu_bar_on_resuming_upower_daemon_resuming, self, 0);
#line 194 "menubar.vala"
			menu_bar_query_upower_daemon (self);
#line 195 "menubar.vala"
			g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 60000, _menu_bar_query_upower_daemon_gsource_func, g_object_ref (self), g_object_unref);
#line 185 "menubar.vala"
			_g_object_unref0 (_tmp42_);
#line 5492 "menubar.c"
		}
		goto __finally0;
		__catch0_g_io_error:
		{
			GError* e = NULL;
			GError* _tmp51_;
			const gchar* _tmp52_;
#line 185 "menubar.vala"
			e = _inner_error0_;
#line 185 "menubar.vala"
			_inner_error0_ = NULL;
#line 198 "menubar.vala"
			_tmp51_ = e;
#line 198 "menubar.vala"
			_tmp52_ = _tmp51_->message;
#line 198 "menubar.vala"
			g_warning ("menubar.vala:198: Could not connect to Upower: %s", _tmp52_);
#line 185 "menubar.vala"
			_g_error_free0 (e);
#line 5512 "menubar.c"
		}
		__finally0:
#line 185 "menubar.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 185 "menubar.vala"
			_g_object_unref0 (hbox);
#line 185 "menubar.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 185 "menubar.vala"
			g_clear_error (&_inner_error0_);
#line 5523 "menubar.c"
		}
#line 166 "menubar.vala"
		_g_object_unref0 (hbox);
#line 5527 "menubar.c"
	}
#line 202 "menubar.vala"
	if (ug_settings_get_boolean (UG_SETTINGS_KEY_SHOW_KEYBOARD)) {
#line 5531 "menubar.c"
		GtkMenuItem* keyboard_menu = NULL;
		GtkMenuItem* _tmp53_;
		GtkMenuItem* _tmp54_;
#line 204 "menubar.vala"
		_tmp53_ = menu_bar_make_keyboard_item (self);
#line 204 "menubar.vala"
		keyboard_menu = _tmp53_;
#line 205 "menubar.vala"
		_tmp54_ = keyboard_menu;
#line 205 "menubar.vala"
		gtk_menu_shell_append ((GtkMenuShell*) self, _tmp54_);
#line 202 "menubar.vala"
		_g_object_unref0 (keyboard_menu);
#line 5545 "menubar.c"
	}
#line 208 "menubar.vala"
	if (ug_settings_get_boolean (UG_SETTINGS_KEY_SHOW_A11Y)) {
#line 5549 "menubar.c"
		GtkMenuItem* a11y_item = NULL;
		GtkMenuItem* _tmp55_;
		GtkMenuItem* _tmp56_;
#line 210 "menubar.vala"
		_tmp55_ = menu_bar_make_a11y_item (self);
#line 210 "menubar.vala"
		a11y_item = _tmp55_;
#line 211 "menubar.vala"
		_tmp56_ = a11y_item;
#line 211 "menubar.vala"
		gtk_menu_shell_append ((GtkMenuShell*) self, _tmp56_);
#line 208 "menubar.vala"
		_g_object_unref0 (a11y_item);
#line 5563 "menubar.c"
	}
#line 214 "menubar.vala"
	if (ug_settings_get_boolean (UG_SETTINGS_KEY_SHOW_HOSTNAME)) {
#line 5567 "menubar.c"
		GtkLabel* label = NULL;
		struct utsname _tmp57_ = {0};
		const gchar* _tmp58_;
		GtkLabel* _tmp59_;
		GdkRGBA hostname_fg = {0};
		GtkLabel* _tmp60_;
		GtkStyleContext* _tmp61_;
		GdkRGBA _tmp62_ = {0};
		GtkLabel* _tmp63_;
		GdkRGBA _tmp64_;
		GtkLabel* _tmp65_;
		GtkMenuItem* hostname_item = NULL;
		GtkMenuItem* _tmp66_;
		GtkMenuItem* _tmp67_;
		GtkLabel* _tmp68_;
		GtkMenuItem* _tmp69_;
		GtkMenuItem* _tmp70_;
		GtkMenuItem* _tmp71_;
		GtkMenuItem* _tmp72_;
#line 216 "menubar.vala"
		uname (&_tmp57_);
#line 216 "menubar.vala"
		_tmp58_ = _tmp57_.nodename;
#line 216 "menubar.vala"
		_tmp59_ = (GtkLabel*) gtk_label_new (_tmp58_);
#line 216 "menubar.vala"
		g_object_ref_sink (_tmp59_);
#line 216 "menubar.vala"
		label = _tmp59_;
#line 217 "menubar.vala"
		_tmp60_ = label;
#line 217 "menubar.vala"
		_tmp61_ = gtk_widget_get_style_context ((GtkWidget*) _tmp60_);
#line 217 "menubar.vala"
		gtk_style_context_get_color (_tmp61_, GTK_STATE_FLAG_NORMAL, &_tmp62_);
#line 217 "menubar.vala"
		hostname_fg = _tmp62_;
#line 218 "menubar.vala"
		_tmp63_ = label;
#line 218 "menubar.vala"
		_tmp64_ = hostname_fg;
#line 218 "menubar.vala"
		gtk_widget_override_color ((GtkWidget*) _tmp63_, GTK_STATE_FLAG_INSENSITIVE, &_tmp64_);
#line 219 "menubar.vala"
		_tmp65_ = label;
#line 219 "menubar.vala"
		gtk_widget_show ((GtkWidget*) _tmp65_);
#line 220 "menubar.vala"
		_tmp66_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 220 "menubar.vala"
		g_object_ref_sink (_tmp66_);
#line 220 "menubar.vala"
		hostname_item = _tmp66_;
#line 221 "menubar.vala"
		_tmp67_ = hostname_item;
#line 221 "menubar.vala"
		_tmp68_ = label;
#line 221 "menubar.vala"
		gtk_container_add ((GtkContainer*) _tmp67_, (GtkWidget*) _tmp68_);
#line 222 "menubar.vala"
		_tmp69_ = hostname_item;
#line 222 "menubar.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp69_, FALSE);
#line 223 "menubar.vala"
		_tmp70_ = hostname_item;
#line 223 "menubar.vala"
		gtk_menu_item_set_right_justified (_tmp70_, TRUE);
#line 224 "menubar.vala"
		_tmp71_ = hostname_item;
#line 224 "menubar.vala"
		gtk_widget_show ((GtkWidget*) _tmp71_);
#line 225 "menubar.vala"
		_tmp72_ = hostname_item;
#line 225 "menubar.vala"
		gtk_menu_shell_append ((GtkMenuShell*) self, _tmp72_);
#line 214 "menubar.vala"
		_g_object_unref0 (hostname_item);
#line 214 "menubar.vala"
		_g_object_unref0 (label);
#line 5647 "menubar.c"
	}
	{
		GtkCssProvider* style = NULL;
		GtkCssProvider* _tmp73_;
		GtkCssProvider* _tmp74_;
		GtkStyleContext* _tmp75_;
		GtkCssProvider* _tmp76_;
#line 231 "menubar.vala"
		_tmp73_ = gtk_css_provider_new ();
#line 231 "menubar.vala"
		style = _tmp73_;
#line 232 "menubar.vala"
		_tmp74_ = style;
#line 232 "menubar.vala"
		gtk_css_provider_load_from_data (_tmp74_, "* {-GtkWidget-window-dragging: false;}", (gssize) -1, &_inner_error0_);
#line 232 "menubar.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 232 "menubar.vala"
			_g_object_unref0 (style);
#line 5667 "menubar.c"
			goto __catch1_g_error;
		}
#line 233 "menubar.vala"
		_tmp75_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 233 "menubar.vala"
		_tmp76_ = style;
#line 233 "menubar.vala"
		gtk_style_context_add_provider (_tmp75_, (GtkStyleProvider*) _tmp76_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 229 "menubar.vala"
		_g_object_unref0 (style);
#line 5678 "menubar.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp77_;
		const gchar* _tmp78_;
#line 229 "menubar.vala"
		e = _inner_error0_;
#line 229 "menubar.vala"
		_inner_error0_ = NULL;
#line 237 "menubar.vala"
		_tmp77_ = e;
#line 237 "menubar.vala"
		_tmp78_ = _tmp77_->message;
#line 237 "menubar.vala"
		g_debug ("menubar.vala:237: Internal error loading menubar style: %s", _tmp78_);
#line 229 "menubar.vala"
		_g_error_free0 (e);
#line 5698 "menubar.c"
	}
	__finally1:
#line 229 "menubar.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 229 "menubar.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 229 "menubar.vala"
		g_clear_error (&_inner_error0_);
#line 5707 "menubar.c"
	}
#line 240 "menubar.vala"
	_tmp79_ = slick_greeter_singleton;
#line 240 "menubar.vala"
	g_signal_connect_object (_tmp79_, "starting-session", (GCallback) _menu_bar_cleanup_slick_greeter_starting_session, self, 0);
#line 138 "menubar.vala"
	return obj;
#line 5715 "menubar.c"
}

static void
menu_bar_class_init (MenuBarClass * klass,
                     gpointer klass_data)
{
#line 78 "menubar.vala"
	menu_bar_parent_class = g_type_class_peek_parent (klass);
#line 78 "menubar.vala"
	g_type_class_adjust_private_offset (klass, &MenuBar_private_offset);
#line 78 "menubar.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) menu_bar_real_draw;
#line 78 "menubar.vala"
	((GtkWidgetClass *) klass)->get_preferred_height = (void (*) (GtkWidget*, gint*, gint*)) menu_bar_real_get_preferred_height;
#line 78 "menubar.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_menu_bar_get_property;
#line 78 "menubar.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_menu_bar_set_property;
#line 78 "menubar.vala"
	G_OBJECT_CLASS (klass)->constructor = menu_bar_constructor;
#line 78 "menubar.vala"
	G_OBJECT_CLASS (klass)->finalize = menu_bar_finalize;
#line 78 "menubar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MENU_BAR_BACKGROUND_PROPERTY, menu_bar_properties[MENU_BAR_BACKGROUND_PROPERTY] = g_param_spec_object ("background", "background", "background", TYPE_BACKGROUND, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 78 "menubar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MENU_BAR_HIGH_CONTRAST_PROPERTY, menu_bar_properties[MENU_BAR_HIGH_CONTRAST_PROPERTY] = g_param_spec_boolean ("high-contrast", "high-contrast", "high-contrast", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 78 "menubar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MENU_BAR_KEYBOARD_WINDOW_PROPERTY, menu_bar_properties[MENU_BAR_KEYBOARD_WINDOW_PROPERTY] = g_param_spec_object ("keyboard-window", "keyboard-window", "keyboard-window", gtk_window_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 78 "menubar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MENU_BAR_ACCEL_GROUP_PROPERTY, menu_bar_properties[MENU_BAR_ACCEL_GROUP_PROPERTY] = g_param_spec_object ("accel-group", "accel-group", "accel-group", gtk_accel_group_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 78 "menubar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MENU_BAR_MAIN_WINDOW_PROPERTY, menu_bar_properties[MENU_BAR_MAIN_WINDOW_PROPERTY] = g_param_spec_object ("main-window", "main-window", "main-window", TYPE_MAIN_WINDOW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 5748 "menubar.c"
}

static void
menu_bar_instance_init (MenuBar * self,
                        gpointer klass)
{
#line 78 "menubar.vala"
	self->priv = menu_bar_get_instance_private (self);
#line 80 "menubar.vala"
	self->priv->_background = NULL;
#line 81 "menubar.vala"
	self->priv->_high_contrast = FALSE;
#line 82 "menubar.vala"
	self->priv->_keyboard_window = NULL;
#line 84 "menubar.vala"
	self->priv->_main_window = NULL;
#line 128 "menubar.vala"
	self->priv->keyboard_pid = (GPid) 0;
#line 129 "menubar.vala"
	self->priv->reader_pid = (GPid) 0;
#line 5769 "menubar.c"
}

static void
menu_bar_finalize (GObject * obj)
{
	MenuBar * self;
#line 78 "menubar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MENU_BAR, MenuBar);
#line 80 "menubar.vala"
	_g_object_unref0 (self->priv->_background);
#line 82 "menubar.vala"
	_g_object_unref0 (self->priv->_keyboard_window);
#line 83 "menubar.vala"
	_g_object_unref0 (self->priv->_accel_group);
#line 84 "menubar.vala"
	_g_object_unref0 (self->priv->_main_window);
#line 125 "menubar.vala"
	_g_free0 (self->priv->default_theme_name);
#line 126 "menubar.vala"
	_g_free0 (self->priv->clock_format);
#line 127 "menubar.vala"
	_g_object_unref0 (self->priv->high_contrast_item);
#line 130 "menubar.vala"
	_g_object_unref0 (self->priv->onscreen_keyboard_item);
#line 131 "menubar.vala"
	_g_object_unref0 (self->priv->clock_label);
#line 132 "menubar.vala"
	_g_object_unref0 (self->priv->upowerd);
#line 133 "menubar.vala"
	_g_object_unref0 (self->priv->power_menu_item);
#line 134 "menubar.vala"
	_g_object_unref0 (self->priv->power_label);
#line 135 "menubar.vala"
	_g_object_unref0 (self->priv->power_icon);
#line 78 "menubar.vala"
	G_OBJECT_CLASS (menu_bar_parent_class)->finalize (obj);
#line 5806 "menubar.c"
}

static GType
menu_bar_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MenuBarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) menu_bar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MenuBar), 0, (GInstanceInitFunc) menu_bar_instance_init, NULL };
	GType menu_bar_type_id;
	menu_bar_type_id = g_type_register_static (gtk_menu_bar_get_type (), "MenuBar", &g_define_type_info, 0);
	MenuBar_private_offset = g_type_add_instance_private (menu_bar_type_id, sizeof (MenuBarPrivate));
	return menu_bar_type_id;
}

GType
menu_bar_get_type (void)
{
	static volatile gsize menu_bar_type_id__volatile = 0;
	if (g_once_init_enter (&menu_bar_type_id__volatile)) {
		GType menu_bar_type_id;
		menu_bar_type_id = menu_bar_get_type_once ();
		g_once_init_leave (&menu_bar_type_id__volatile, menu_bar_type_id);
	}
	return menu_bar_type_id__volatile;
}

static void
_vala_menu_bar_get_property (GObject * object,
                             guint property_id,
                             GValue * value,
                             GParamSpec * pspec)
{
	MenuBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MENU_BAR, MenuBar);
#line 78 "menubar.vala"
	switch (property_id) {
#line 78 "menubar.vala"
		case MENU_BAR_BACKGROUND_PROPERTY:
#line 78 "menubar.vala"
		g_value_set_object (value, menu_bar_get_background (self));
#line 78 "menubar.vala"
		break;
#line 78 "menubar.vala"
		case MENU_BAR_HIGH_CONTRAST_PROPERTY:
#line 78 "menubar.vala"
		g_value_set_boolean (value, menu_bar_get_high_contrast (self));
#line 78 "menubar.vala"
		break;
#line 78 "menubar.vala"
		case MENU_BAR_KEYBOARD_WINDOW_PROPERTY:
#line 78 "menubar.vala"
		g_value_set_object (value, menu_bar_get_keyboard_window (self));
#line 78 "menubar.vala"
		break;
#line 78 "menubar.vala"
		case MENU_BAR_ACCEL_GROUP_PROPERTY:
#line 78 "menubar.vala"
		g_value_set_object (value, menu_bar_get_accel_group (self));
#line 78 "menubar.vala"
		break;
#line 78 "menubar.vala"
		case MENU_BAR_MAIN_WINDOW_PROPERTY:
#line 78 "menubar.vala"
		g_value_set_object (value, menu_bar_get_main_window (self));
#line 78 "menubar.vala"
		break;
#line 5871 "menubar.c"
		default:
#line 78 "menubar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 78 "menubar.vala"
		break;
#line 5877 "menubar.c"
	}
}

static void
_vala_menu_bar_set_property (GObject * object,
                             guint property_id,
                             const GValue * value,
                             GParamSpec * pspec)
{
	MenuBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MENU_BAR, MenuBar);
#line 78 "menubar.vala"
	switch (property_id) {
#line 78 "menubar.vala"
		case MENU_BAR_BACKGROUND_PROPERTY:
#line 78 "menubar.vala"
		menu_bar_set_background (self, g_value_get_object (value));
#line 78 "menubar.vala"
		break;
#line 78 "menubar.vala"
		case MENU_BAR_HIGH_CONTRAST_PROPERTY:
#line 78 "menubar.vala"
		menu_bar_set_high_contrast (self, g_value_get_boolean (value));
#line 78 "menubar.vala"
		break;
#line 78 "menubar.vala"
		case MENU_BAR_KEYBOARD_WINDOW_PROPERTY:
#line 78 "menubar.vala"
		menu_bar_set_keyboard_window (self, g_value_get_object (value));
#line 78 "menubar.vala"
		break;
#line 78 "menubar.vala"
		case MENU_BAR_ACCEL_GROUP_PROPERTY:
#line 78 "menubar.vala"
		menu_bar_set_accel_group (self, g_value_get_object (value));
#line 78 "menubar.vala"
		break;
#line 78 "menubar.vala"
		case MENU_BAR_MAIN_WINDOW_PROPERTY:
#line 78 "menubar.vala"
		menu_bar_set_main_window (self, g_value_get_object (value));
#line 78 "menubar.vala"
		break;
#line 5921 "menubar.c"
		default:
#line 78 "menubar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 78 "menubar.vala"
		break;
#line 5927 "menubar.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

